/*
\section{Transaction Identifier Interface}

A transaction identifier is implemented exactly the same as a global
timestamp, but the two are conceptually different.  A transaction
identifier gives a unique ID to a transaction; a global timestamp is a
unique instant in time when the transaction is imagined to occur.  

Since we have FEs defining the timestamp of a transaction, the
timestamp which makes the transaction ID unique is the same as the
transaction's timestamp.

_This is a stack abstraction._ 
*/

#ifndef _TID_H
#define _TID_H

#include "utils/global_tstamp.h"

typedef Global_tstamp Tid;


#endif /* _TID_H */
