/*  java_lang_RuntimeException.h -- from Java class java.lang.RuntimeException  */
/*  created by Toba  */

#ifndef java_lang_RuntimeException_H
#define java_lang_RuntimeException_H

#include "compiler/C/compiler.h"

DECLARE_type(java_lang_RuntimeException);
DECLARE_type(java_lang_RuntimeException_static);

struct java_lang_RuntimeException_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "java_lang_RuntimeException.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Exception.h"
#include "java_lang_Throwable.h"
#include "java_io_Serializable.h"
#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_StringBuffer.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__Uwjei(java_lang_RuntimeException);
extern Void	init_S_44piL(java_lang_RuntimeException, java_lang_String);

#ifdef __cplusplus
}
#endif

struct java_lang_RuntimeException_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__VVof7)(java_lang_Throwable);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*getMessage__AHr9V)(java_lang_Throwable);
	java_lang_String (*getLocalizedMessage__LrsNN)(java_lang_Throwable);
	java_lang_Throwable (*fillInStackTrace__n9rRx)(java_lang_Throwable);
};

struct java_lang_RuntimeException_bidirectional_DV {

	struct java_lang_RuntimeException_P_s *java_lang_RuntimeException_P;
	Void (*init__Uwjei_)(java_lang_RuntimeException);
	Void (*init_S_44piL_)(java_lang_RuntimeException, java_lang_String);

	struct java_lang_Exception_P_s *java_lang_Exception_P;
	Void (*init__mPZpI_)(java_lang_Exception);
	Void (*init_S_cMjwr_)(java_lang_Exception, java_lang_String);

	struct java_lang_Throwable_P_s *java_lang_Throwable_P;
	Void (*init__j7ziV_)(java_lang_Throwable);
	Void (*init_S_5ceOK_)(java_lang_Throwable, java_lang_String);
	java_lang_String (*getMessage__AHr9V_)(java_lang_Throwable);
	java_lang_String (*getLocalizedMessage__LrsNN_)(java_lang_Throwable);
	java_lang_String (*toString__VVof7_)(java_lang_Throwable);
	java_lang_Throwable (*fillInStackTrace__n9rRx_)(java_lang_Throwable);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__VVof7)(java_lang_Throwable);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*getMessage__AHr9V)(java_lang_Throwable);
	java_lang_String (*getLocalizedMessage__LrsNN)(java_lang_Throwable);
	java_lang_Throwable (*fillInStackTrace__n9rRx)(java_lang_Throwable);
};

struct java_lang_RuntimeException_static_DV {

	struct DV_hdr_s hdr;

};

struct java_lang_RuntimeException_static_bidirectional_DV {
	struct java_lang_RuntimeException_P_s *java_lang_RuntimeException_P;

	struct DV_hdr_s hdr;

};

struct java_lang_RuntimeException_P_s {
	struct Class_s *java_lang_RuntimeException_V;
	struct Class_s *java_lang_RuntimeException_static_V;
	struct Class_s *java_lang_Exception_V;
	struct Class_s *java_lang_Exception_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct java_lang_RuntimeException_f_s {
	struct Fields_s inh;
	Shortp th_backtrace;
	Shortp th_detailMessage;
};

struct java_lang_RuntimeException_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *java_lang_RuntimeException_V;
extern struct Class_s *java_lang_RuntimeException_static_V;
extern struct java_lang_RuntimeException_P_s *java_lang_RuntimeException_P;

#endif /* java_lang_RuntimeException_H */
