/*  java_util_Stack.h -- from Java class java.util.Stack  */
/*  created by Toba  */

#ifndef java_util_Stack_H
#define java_util_Stack_H

#include "compiler/C/compiler.h"

DECLARE_type(java_util_Stack);
DECLARE_type(java_util_Stack_static);

struct java_util_Stack_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "java_util_Stack.externs.h"
#include "java/builtins/exports/java.h"

#include "java_util_Vector.h"
#include "java_lang_Cloneable.h"
#include "java_io_Serializable.h"
#include "java_lang_Object.h"
#include "java_util_EmptyStackException.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_util_VectorEnumerator.h"
#include "java_lang_ArrayIndexOutOfBoundsException.h"
#include "java_lang_StringBuffer.h"
#include "java_util_NoSuchElementException.h"
#include "java_util_Enumeration.h"
#include "java_lang_System.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__B4J6L(java_util_Stack);
extern java_lang_Object	push_O_xWhwo(java_util_Stack, java_lang_Object);
extern java_lang_Object	pop__U2jDf(java_util_Stack);
extern java_lang_Object	peek__0flZm(java_util_Stack);
extern Boolean	empty__y4aBH(java_util_Stack);
extern Int	search_O_qjYJ7(java_util_Stack, java_lang_Object);

#ifdef __cplusplus
}
#endif

struct java_util_Stack_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__Q7y8K)(java_util_Vector);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*copyInto_aO_6qaXT)(java_util_Vector, java_lang_Object);
	Void (*trimToSize__8YW9I)(java_util_Vector);
	Void (*ensureCapacity_i_Jdi61)(java_util_Vector, Int);
	Void (*setSize_i_ykYkM)(java_util_Vector, Int);
	Int (*capacity__3wNyS)(java_util_Vector);
	Int (*size__IEjK1)(java_util_Vector);
	Boolean (*isEmpty__vLYvD)(java_util_Vector);
	java_util_Enumeration (*elements__BcaYI)(java_util_Vector);
	Boolean (*contains_O_Ra5bc)(java_util_Vector, java_lang_Object);
	Int (*indexOf_O_YDrWc)(java_util_Vector, java_lang_Object);
	Int (*indexOf_Oi_TctTw)(java_util_Vector, java_lang_Object, Int);
	Int (*lastIndexOf_O_kDOlD)(java_util_Vector, java_lang_Object);
	Int (*lastIndexOf_Oi_jGuII)(java_util_Vector, java_lang_Object, Int);
	java_lang_Object (*elementAt_i_kG7lR)(java_util_Vector, Int);
	java_lang_Object (*firstElement__ek7HB)(java_util_Vector);
	java_lang_Object (*lastElement__OUxy1)(java_util_Vector);
	Void (*setElementAt_Oi_kTiBm)(java_util_Vector, java_lang_Object, Int);
	Void (*removeElementAt_i_SXIxd)(java_util_Vector, Int);
	Void (*insertElementAt_Oi_l9TGp)(java_util_Vector, java_lang_Object, Int);
	Void (*addElement_O_zF3CH)(java_util_Vector, java_lang_Object);
	Boolean (*removeElement_O_KsT2e)(java_util_Vector, java_lang_Object);
	Void (*removeAllElements__eQdEb)(java_util_Vector);
	java_lang_Object (*push_O_xWhwo)(java_util_Stack, java_lang_Object);
	java_lang_Object (*pop__U2jDf)(java_util_Stack);
	java_lang_Object (*peek__0flZm)(java_util_Stack);
	Boolean (*empty__y4aBH)(java_util_Stack);
	Int (*search_O_qjYJ7)(java_util_Stack, java_lang_Object);
};

struct java_util_Stack_bidirectional_DV {

	struct java_util_Stack_P_s *java_util_Stack_P;
	Void (*init__B4J6L_)(java_util_Stack);
	java_lang_Object (*push_O_xWhwo_)(java_util_Stack, java_lang_Object);
	java_lang_Object (*pop__U2jDf_)(java_util_Stack);
	java_lang_Object (*peek__0flZm_)(java_util_Stack);
	Boolean (*empty__y4aBH_)(java_util_Stack);
	Int (*search_O_qjYJ7_)(java_util_Stack, java_lang_Object);

	struct java_util_Vector_P_s *java_util_Vector_P;
	Void (*init_ii_OSv0c_)(java_util_Vector, Int, Int);
	Void (*init_i_37PTe_)(java_util_Vector, Int);
	Void (*init__kkKK3_)(java_util_Vector);
	Void (*copyInto_aO_6qaXT_)(java_util_Vector, java_lang_Object);
	Void (*trimToSize__8YW9I_)(java_util_Vector);
	Void (*ensureCapacity_i_Jdi61_)(java_util_Vector, Int);
	Void (*setSize_i_ykYkM_)(java_util_Vector, Int);
	Int (*capacity__3wNyS_)(java_util_Vector);
	Int (*size__IEjK1_)(java_util_Vector);
	Boolean (*isEmpty__vLYvD_)(java_util_Vector);
	java_util_Enumeration (*elements__BcaYI_)(java_util_Vector);
	Boolean (*contains_O_Ra5bc_)(java_util_Vector, java_lang_Object);
	Int (*indexOf_O_YDrWc_)(java_util_Vector, java_lang_Object);
	Int (*indexOf_Oi_TctTw_)(java_util_Vector, java_lang_Object, Int);
	Int (*lastIndexOf_O_kDOlD_)(java_util_Vector, java_lang_Object);
	Int (*lastIndexOf_Oi_jGuII_)(java_util_Vector, java_lang_Object, Int);
	java_lang_Object (*elementAt_i_kG7lR_)(java_util_Vector, Int);
	java_lang_Object (*firstElement__ek7HB_)(java_util_Vector);
	java_lang_Object (*lastElement__OUxy1_)(java_util_Vector);
	Void (*setElementAt_Oi_kTiBm_)(java_util_Vector, java_lang_Object, Int);
	Void (*removeElementAt_i_SXIxd_)(java_util_Vector, Int);
	Void (*insertElementAt_Oi_l9TGp_)(java_util_Vector, java_lang_Object, Int);
	Void (*addElement_O_zF3CH_)(java_util_Vector, java_lang_Object);
	Boolean (*removeElement_O_KsT2e_)(java_util_Vector, java_lang_Object);
	Void (*removeAllElements__eQdEb_)(java_util_Vector);
	java_lang_String (*toString__Q7y8K_)(java_util_Vector);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__Q7y8K)(java_util_Vector);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*copyInto_aO_6qaXT)(java_util_Vector, java_lang_Object);
	Void (*trimToSize__8YW9I)(java_util_Vector);
	Void (*ensureCapacity_i_Jdi61)(java_util_Vector, Int);
	Void (*setSize_i_ykYkM)(java_util_Vector, Int);
	Int (*capacity__3wNyS)(java_util_Vector);
	Int (*size__IEjK1)(java_util_Vector);
	Boolean (*isEmpty__vLYvD)(java_util_Vector);
	java_util_Enumeration (*elements__BcaYI)(java_util_Vector);
	Boolean (*contains_O_Ra5bc)(java_util_Vector, java_lang_Object);
	Int (*indexOf_O_YDrWc)(java_util_Vector, java_lang_Object);
	Int (*indexOf_Oi_TctTw)(java_util_Vector, java_lang_Object, Int);
	Int (*lastIndexOf_O_kDOlD)(java_util_Vector, java_lang_Object);
	Int (*lastIndexOf_Oi_jGuII)(java_util_Vector, java_lang_Object, Int);
	java_lang_Object (*elementAt_i_kG7lR)(java_util_Vector, Int);
	java_lang_Object (*firstElement__ek7HB)(java_util_Vector);
	java_lang_Object (*lastElement__OUxy1)(java_util_Vector);
	Void (*setElementAt_Oi_kTiBm)(java_util_Vector, java_lang_Object, Int);
	Void (*removeElementAt_i_SXIxd)(java_util_Vector, Int);
	Void (*insertElementAt_Oi_l9TGp)(java_util_Vector, java_lang_Object, Int);
	Void (*addElement_O_zF3CH)(java_util_Vector, java_lang_Object);
	Boolean (*removeElement_O_KsT2e)(java_util_Vector, java_lang_Object);
	Void (*removeAllElements__eQdEb)(java_util_Vector);
	java_lang_Object (*push_O_xWhwo)(java_util_Stack, java_lang_Object);
	java_lang_Object (*pop__U2jDf)(java_util_Stack);
	java_lang_Object (*peek__0flZm)(java_util_Stack);
	Boolean (*empty__y4aBH)(java_util_Stack);
	Int (*search_O_qjYJ7)(java_util_Stack, java_lang_Object);
};

struct java_util_Stack_static_DV {

	struct DV_hdr_s hdr;

};

struct java_util_Stack_static_bidirectional_DV {
	struct java_util_Stack_P_s *java_util_Stack_P;

	struct DV_hdr_s hdr;

};

struct java_util_Stack_P_s {
	struct Class_s *java_util_EmptyStackException_V;
	struct Class_s *java_util_EmptyStackException_static_V;
	struct Class_s *java_util_Stack_V;
	struct Class_s *java_util_Stack_static_V;
	struct Class_s *java_util_Vector_V;
	struct Class_s *java_util_Vector_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct java_util_Stack_f_s {
	struct Fields_s inh;
	Shortp th_elementData;
	Int th_elementCount;
	Int th_capacityIncrement;
};

struct java_util_Stack_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *java_util_Stack_V;
extern struct Class_s *java_util_Stack_static_V;
extern struct java_util_Stack_P_s *java_util_Stack_P;

#endif /* java_util_Stack_H */
