/*  Assembly.c -- from Java class Assembly  */
/*  created by Toba  */

#include "Assembly.h"

struct Class_s *Assembly_V;
struct Class_s *Assembly_static_V;

struct Assembly_P_s *Assembly_P;


static Char ch_Assembly[];
static Char *st_Assembly[];

static java_lang_String strings_Assembly[];


/*M init__byJNJ: Assembly.<init>()V */

Void init__byJNJ(Assembly p0)
{
Object a0, a1;
Object av0;

	SETUP_SELF(p0, Assembly);
	MARK_USED(p0);

	av0 = p0;

L0:	a1 = av0;
	if (a1 == JAVA_NULL) goto NULLX;
	DISPATCH_N_D(a1, init__wdMWi_, DesignObj)(a1);
	return;

NULLX:
	THROW(java_lang_NullPointerException);
}

static struct Class_s * supers[3];
static struct Class_s * inters[1]; /* Actually 0 */
static struct Class_s * others[3];


static struct Method_s Assembly_methods[] = {
	{-1992104095, (void(*)())hashCode__8wJNW},
	{-1028981426, (void(*)())equals_O_Ba6e0},
	{1218416239, (void(*)())toString__4d9OF},
	{-1526933051, (void(*)())finalize__UKxhs},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
};

struct Assembly_bidirectional_DV The_Assembly_DV = {

	0, /* Assembly_P */
	(Void (*)(Assembly)) init__byJNJ,
	(Void (*)(Assembly, ComplexAssembly)) 0,
	(ComplexAssembly (*)(Assembly)) 0,
	(Int (*)(Assembly, Traversal)) 0,
	(Int (*)(Assembly, Traversal)) 0,
	(Int (*)(Assembly, Traversal)) 0,

	0, /* DesignObj_P */
	(Void (*)(DesignObj)) init__wdMWi,
	(Int (*)(DesignObj)) 0,
	(Int (*)(DesignObj)) 0,
	(Void (*)(DesignObj, Int)) 0,
	(java_lang_Object (*)(DesignObj)) 0,

	0, /* java_lang_Object_P */
	(Void (*)(java_lang_Object)) init__AAyKx,
	(Int (*)(java_lang_Object)) hashCode__8wJNW,
	(Boolean (*)(java_lang_Object, java_lang_Object)) equals_O_Ba6e0,
	(java_lang_String (*)(java_lang_Object)) toString__4d9OF,
	(Void (*)(java_lang_Object)) finalize__UKxhs,
	{
		0, 			/* self_class */
		0x0, 			/* bf */
		0, 			/* num_slots */
		13, 			/* num_methods */
		&Assembly_methods[0], 	/* methods */
		3, 			/* nsupers */
		supers, 
		0, 			/* ninters */
		0, 			/* ndinters */
		inters, 
		3, 			/* nothers */
		others, 
	},
	(Int (*)(java_lang_Object)) hashCode__8wJNW,
	(Boolean (*)(java_lang_Object, java_lang_Object)) equals_O_Ba6e0,
	(java_lang_String (*)(java_lang_Object)) toString__4d9OF,
	(Void (*)(java_lang_Object)) finalize__UKxhs,
	(Int (*)(DesignObj)) 0,
	(Int (*)(DesignObj)) 0,
	(Void (*)(DesignObj, Int)) 0,
	(java_lang_Object (*)(DesignObj)) 0,
	(Void (*)(Assembly, ComplexAssembly)) 0,
	(ComplexAssembly (*)(Assembly)) 0,
	(Int (*)(Assembly, Traversal)) 0,
	(Int (*)(Assembly, Traversal)) 0,
	(Int (*)(Assembly, Traversal)) 0,
};

struct Assembly_static_bidirectional_DV The_Assembly_static_DV = {
	0, /* Assembly_P */
	{
		0, 			/* self_class */
		0x0, 			/* bf */
		0, 			/* num_slots */

		/* The following fields are not used for static objects */

		0, 			/* num_methods */
		0, 			/* methods */
		0, 			/* nsupers */
		0, 			/* supers */
		0, 			/* ninters */
		0, 			/* ndinters */
		0, 			/* inters */
		0, 			/* nothers */
		0, 			/* others */
	},
};


void Init_Assembly()
{
	struct Assembly_bidirectional_DV *self_dv;
	struct Assembly_P_s *self_P;
	Assembly_static static_obj;

	int i,j;
	Char *start, *end;

	if (Assembly_V != 0) return;
	Assembly_V = NEW_CLASS();
	Assembly_static_V = NEW_CLASS();
	Assembly_P = NEW(struct Assembly_P_s);

	CREATE_DV(Assembly);
	CREATE_DV(Assembly_static);
	ALLOC_OBJ_G(static_obj, Assembly_static);
	Pin_object((Obj_p) static_obj);
	Assembly_static_V->static_obj = (Obj_p) static_obj;


	th_assert((sizeof(struct Assembly_f_s) + Slot_size -1)/Slot_size == 1,
		"Mismatch in num_slots calculation");
	th_assert((sizeof(struct Assembly_static_f_s)+Slot_size-1)/Slot_size == 1,
		"Mismatch in num_slots calculation");

	Init_DesignObj();
	Init_java_lang_Object();
	Init_java_lang_String();
	Init_java_lang_Class();
	Init_java_lang_NullPointerException();

	The_Assembly_DV.Assembly_P = Assembly_P;
	The_Assembly_DV.DesignObj_P = DesignObj_P;
	The_Assembly_DV.java_lang_Object_P = java_lang_Object_P;

	The_Assembly_static_DV.Assembly_P = Assembly_P;

	supers[0] = Assembly_V;
	supers[1] = DesignObj_V;
	supers[2] = java_lang_Object_V;
	others[0] = java_lang_String_V;
	others[1] = java_lang_Class_V;
	others[2] = java_lang_NullPointerException_V;

	Assembly_V->flags = (IS_CLASS | IS_PERSISTABLE);
	CREATE_DV(Assembly);

	Assembly_static_V->flags = IS_STATIC;
	CREATE_DV(Assembly_static);
	SET_DV(static_obj, Assembly_static_V->dv);

	self_dv = & The_Assembly_DV;
	self_P = self_dv->Assembly_P;

	Assembly_P->Assembly_V = Assembly_V;
	Assembly_P->Assembly_static_V = Assembly_static_V;
	Assembly_P->DesignObj_V = DesignObj_V;
	Assembly_P->DesignObj_static_V = DesignObj_static_V;
	Assembly_P->java_lang_Object_V = java_lang_Object_V;
	Assembly_P->java_lang_Object_static_V = java_lang_Object_static_V;
	Assembly_P->java_lang_String_V = java_lang_String_V;
	Assembly_P->java_lang_String_static_V = java_lang_String_static_V;
	Assembly_P->java_lang_Class_V = java_lang_Class_V;
	Assembly_P->java_lang_Class_static_V = java_lang_Class_static_V;
	Assembly_P->java_lang_NullPointerException_V = java_lang_NullPointerException_V;
	Assembly_P->java_lang_NullPointerException_static_V = java_lang_NullPointerException_static_V;
	Assembly_P->Char_Array_0_V = Char_V;
	Assembly_P->Char_Array_1_V = Instantiate_array(Char_V);

	start = ch_Assembly;
	for (i=0; st_Assembly[i] != NULL; i++) {
		java_lang_String s;
		struct java_lang_String_f_s *s_f;
		Char_Array c;
		struct Char_Array_f_s *c_f;
		int n;
		end = st_Assembly[i];
		n = (end - start);
		ALLOC_ARRAY_V(c, Char, n);
		c_f = FIX_FIELDS(c, Char_Array);
		for(j=0; j<n; j++) {
			PUTAV_F(c_f, j, start[j], Char);
		}
		ALLOC_OBJ(s, java_lang_String);
		Pin_object((Obj_p) s);
		s_f = FIX_FIELDS(s, java_lang_String);
		PREPARE_PWRITE_F(s_f);
		PUTP_F(s_f, th_value, c, java_lang_String);
		PUTV_F(s_f, th_offset, 0, java_lang_String);
		PUTV_F(s_f, th_count, (end-start), java_lang_String);
		strings_Assembly[i] = s;
		start=end;
	}
	Assembly_V->strings = (Obj_p *)strings_Assembly;
	Assembly_static_V->strings = (Obj_p *)strings_Assembly;

	Assembly_V->name = Assembly_V->strings[0];
	Assembly_static_V->name = Assembly_V->strings[0];
};



static Char ch_Assembly[] = {  /* string pool */
'A','s','s','e','m','b','l','y',0};

static Char *st_Assembly[] = {
	ch_Assembly+8,	/* 0. Assembly */
	0};

static java_lang_String strings_Assembly[] = {
	/* To be initialized at boot time */

	0,	/* Assembly */

	0};
