/*  Assembly.h -- from Java class Assembly  */
/*  created by Toba  */

#ifndef Assembly_H
#define Assembly_H

#include "compiler/C/compiler.h"

DECLARE_type(Assembly);
DECLARE_type(Assembly_static);

struct Assembly_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Assembly.externs.h"
#include "java/builtins/exports/java.h"

#include "DesignObj.h"
#include "java_lang_Object.h"
#include "ComplexAssembly.h"
#include "Traversal.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__byJNJ(Assembly);
extern Void	init_superAssembly_C_UVr8t(Assembly, ComplexAssembly);
extern ComplexAssembly	superAssembly__p0FT8(Assembly);
extern Int	traverse_T_H8Gln(Assembly, Traversal);
extern Int	traverse_random_T_Xo0Pr(Assembly, Traversal);
extern Int	traverse_random_path_T_lV5D1(Assembly, Traversal);

#ifdef __cplusplus
}
#endif

struct Assembly_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__ipnn9)(DesignObj);
	Int (*buildDate__xUkLN)(DesignObj);
	Void (*set_buildDate_i_eM690)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR)(DesignObj);
	Void (*init_superAssembly_C_UVr8t)(Assembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__p0FT8)(Assembly);
	Int (*traverse_T_H8Gln)(Assembly, Traversal);
	Int (*traverse_random_T_Xo0Pr)(Assembly, Traversal);
	Int (*traverse_random_path_T_lV5D1)(Assembly, Traversal);
};

struct Assembly_bidirectional_DV {

	struct Assembly_P_s *Assembly_P;
	Void (*init__byJNJ_)(Assembly);
	Void (*init_superAssembly_C_UVr8t_)(Assembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__p0FT8_)(Assembly);
	Int (*traverse_T_H8Gln_)(Assembly, Traversal);
	Int (*traverse_random_T_Xo0Pr_)(Assembly, Traversal);
	Int (*traverse_random_path_T_lV5D1_)(Assembly, Traversal);

	struct DesignObj_P_s *DesignObj_P;
	Void (*init__wdMWi_)(DesignObj);
	Int (*id__ipnn9_)(DesignObj);
	Int (*buildDate__xUkLN_)(DesignObj);
	Void (*set_buildDate_i_eM690_)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR_)(DesignObj);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__ipnn9)(DesignObj);
	Int (*buildDate__xUkLN)(DesignObj);
	Void (*set_buildDate_i_eM690)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR)(DesignObj);
	Void (*init_superAssembly_C_UVr8t)(Assembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__p0FT8)(Assembly);
	Int (*traverse_T_H8Gln)(Assembly, Traversal);
	Int (*traverse_random_T_Xo0Pr)(Assembly, Traversal);
	Int (*traverse_random_path_T_lV5D1)(Assembly, Traversal);
};

struct Assembly_static_DV {

	struct DV_hdr_s hdr;

};

struct Assembly_static_bidirectional_DV {
	struct Assembly_P_s *Assembly_P;

	struct DV_hdr_s hdr;

};

struct Assembly_P_s {
	struct Class_s *Assembly_V;
	struct Class_s *Assembly_static_V;
	struct Class_s *DesignObj_V;
	struct Class_s *DesignObj_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct Assembly_f_s {
	struct Fields_s inh;
};

struct Assembly_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Assembly_V;
extern struct Class_s *Assembly_static_V;
extern struct Assembly_P_s *Assembly_P;

#endif /* Assembly_H */
