/*  Meeting.h -- from Java class Meeting  */
/*  created by Toba  */

#ifndef Meeting_H
#define Meeting_H

#include "compiler/C/compiler.h"

DECLARE_type(Meeting);
DECLARE_type(Meeting_static);

struct Meeting_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Meeting.externs.h"
#include "java/builtins/exports/java.h"

#include "Item.h"
#include "java_lang_Object.h"
#include "Time.h"
#include "java_lang_String.h"
#include "Date.h"
#include "Util.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_SS_SfLH4(Meeting, java_lang_String, java_lang_String);
extern Void	init_SSDDTT_COGix(Meeting, java_lang_String, java_lang_String, Date, Date, Time, Time);
extern Time	startTime__hjiyk(Meeting);
extern Time	endTime__c80Yw(Meeting);
extern Int	length__DSeZr(Meeting);
extern java_lang_Object	write__a5huP(Meeting);
extern java_lang_String	toString__O2sgv(Meeting);

#ifdef __cplusplus
}
#endif

struct Meeting_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__O2sgv)(Meeting);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__a5huP)(Meeting);
	Time (*startTime__hjiyk)(Meeting);
	Time (*endTime__c80Yw)(Meeting);
	Int (*length__DSeZr)(Meeting);
};

struct Meeting_bidirectional_DV {

	struct Meeting_P_s *Meeting_P;
	Void (*init_SS_SfLH4_)(Meeting, java_lang_String, java_lang_String);
	Void (*init_SSDDTT_COGix_)(Meeting, java_lang_String, java_lang_String, Date, Date, Time, Time);
	Time (*startTime__hjiyk_)(Meeting);
	Time (*endTime__c80Yw_)(Meeting);
	Int (*length__DSeZr_)(Meeting);
	java_lang_Object (*write__a5huP_)(Meeting);
	java_lang_String (*toString__O2sgv_)(Meeting);

	struct Item_P_s *Item_P;
	Void (*init_SS_kc5aC_)(Item, java_lang_String, java_lang_String);
	Void (*init_SSDD_C4nTP_)(Item, java_lang_String, java_lang_String, Date, Date);
	java_lang_String (*name__l8fXo_)(Item);
	java_lang_String (*description__6FG4o_)(Item);
	Date (*start__pFEMI_)(Item);
	Date (*finish__y6rtU_)(Item);
	java_lang_Object (*write__ke04G_)(Item);
	java_lang_String (*toString__y21AC_)(Item);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__O2sgv)(Meeting);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__a5huP)(Meeting);
	Time (*startTime__hjiyk)(Meeting);
	Time (*endTime__c80Yw)(Meeting);
	Int (*length__DSeZr)(Meeting);
};

struct Meeting_static_DV {

	struct DV_hdr_s hdr;

};

struct Meeting_static_bidirectional_DV {
	struct Meeting_P_s *Meeting_P;

	struct DV_hdr_s hdr;

};

struct Meeting_P_s {
	struct Class_s *Time_V;
	struct Class_s *Time_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Meeting_V;
	struct Class_s *Meeting_static_V;
	struct Class_s *Item_V;
	struct Class_s *Item_static_V;
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
};

struct Meeting_f_s {
	struct Fields_s inh;
	Shortp th_name;
	Shortp th_description;
	Shortp th_start;
	Shortp th_finish;
	Shortp th_startTime;
	Shortp th_endTime;
	Int th_length;
};

struct Meeting_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Meeting_V;
extern struct Class_s *Meeting_static_V;
extern struct Meeting_P_s *Meeting_P;

#endif /* Meeting_H */
