/*  Assembly.externs.h -- from Java class Assembly  */
/*  created by Toba  */

#ifndef Assembly_EXTERNS_H
#define Assembly_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Assembly();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Assembly_V;
extern struct Class_s *Assembly_static_V;

#endif /* Assembly_EXTERNS_H */
/*  Assembly.h -- from Java class Assembly  */
/*  created by Toba  */

#ifndef Assembly_H
#define Assembly_H

#include "compiler/C/compiler.h"

DECLARE_type(Assembly);
DECLARE_type(Assembly_static);

struct Assembly_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Assembly.externs.h"
#include "java/builtins/exports/java.h"

#include "DesignObj.h"
#include "java_lang_Object.h"
#include "ComplexAssembly.h"
#include "Traversal.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__byJNJ(Assembly);
extern Void	init_superAssembly_C_UVr8t(Assembly, ComplexAssembly);
extern ComplexAssembly	superAssembly__p0FT8(Assembly);
extern Int	traverse_T_H8Gln(Assembly, Traversal);
extern Int	traverse_random_T_Xo0Pr(Assembly, Traversal);
extern Int	traverse_random_path_T_lV5D1(Assembly, Traversal);

#ifdef __cplusplus
}
#endif

struct Assembly_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__ipnn9)(DesignObj);
	Int (*buildDate__xUkLN)(DesignObj);
	Void (*set_buildDate_i_eM690)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR)(DesignObj);
	Void (*init_superAssembly_C_UVr8t)(Assembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__p0FT8)(Assembly);
	Int (*traverse_T_H8Gln)(Assembly, Traversal);
	Int (*traverse_random_T_Xo0Pr)(Assembly, Traversal);
	Int (*traverse_random_path_T_lV5D1)(Assembly, Traversal);
};

struct Assembly_bidirectional_DV {

	struct Assembly_P_s *Assembly_P;
	Void (*init__byJNJ_)(Assembly);
	Void (*init_superAssembly_C_UVr8t_)(Assembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__p0FT8_)(Assembly);
	Int (*traverse_T_H8Gln_)(Assembly, Traversal);
	Int (*traverse_random_T_Xo0Pr_)(Assembly, Traversal);
	Int (*traverse_random_path_T_lV5D1_)(Assembly, Traversal);

	struct DesignObj_P_s *DesignObj_P;
	Void (*init__wdMWi_)(DesignObj);
	Int (*id__ipnn9_)(DesignObj);
	Int (*buildDate__xUkLN_)(DesignObj);
	Void (*set_buildDate_i_eM690_)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR_)(DesignObj);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__ipnn9)(DesignObj);
	Int (*buildDate__xUkLN)(DesignObj);
	Void (*set_buildDate_i_eM690)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR)(DesignObj);
	Void (*init_superAssembly_C_UVr8t)(Assembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__p0FT8)(Assembly);
	Int (*traverse_T_H8Gln)(Assembly, Traversal);
	Int (*traverse_random_T_Xo0Pr)(Assembly, Traversal);
	Int (*traverse_random_path_T_lV5D1)(Assembly, Traversal);
};

struct Assembly_static_DV {

	struct DV_hdr_s hdr;

};

struct Assembly_static_bidirectional_DV {
	struct Assembly_P_s *Assembly_P;

	struct DV_hdr_s hdr;

};

struct Assembly_P_s {
	struct Class_s *Assembly_V;
	struct Class_s *Assembly_static_V;
	struct Class_s *DesignObj_V;
	struct Class_s *DesignObj_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct Assembly_f_s {
	struct Fields_s inh;
};

struct Assembly_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Assembly_V;
extern struct Class_s *Assembly_static_V;
extern struct Assembly_P_s *Assembly_P;

#endif /* Assembly_H */
/*  AtomicPart.externs.h -- from Java class AtomicPart  */
/*  created by Toba  */

#ifndef AtomicPart_EXTERNS_H
#define AtomicPart_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_AtomicPart();

#ifdef __cplusplus
}
#endif

extern struct Class_s *AtomicPart_V;
extern struct Class_s *AtomicPart_static_V;

#endif /* AtomicPart_EXTERNS_H */
/*  AtomicPart.h -- from Java class AtomicPart  */
/*  created by Toba  */

#ifndef AtomicPart_H
#define AtomicPart_H

#include "compiler/C/compiler.h"

DECLARE_type(AtomicPart);
DECLARE_type(AtomicPart_static);

struct AtomicPart_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "AtomicPart.externs.h"
#include "java/builtins/exports/java.h"

#include "DesignObj.h"
#include "java_lang_Object.h"
#include "CompositePart.h"
#include "Connection.h"
#include "Traversal.h"
#include "OO7_Creator.h"
#include "intset.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__nsJ0H(AtomicPart);
extern Void	init_iiabiiiC_AZ9K8(AtomicPart, Int, Int, java_lang_Object, Int, Int, Int, CompositePart);
extern Int	id__hY8XQ(AtomicPart);
extern Int	buildDate__EX3oc(AtomicPart);
extern Void	set_buildDate_i_1rT4n(AtomicPart, Int);
extern java_lang_Object	otype__bHA9k(AtomicPart);
extern Int	docId__hLvfd(AtomicPart);
extern Int	x__cuk3k(AtomicPart);
extern Void	set_x_i_3rjyY(AtomicPart, Int);
extern Int	y__bFx3k(AtomicPart);
extern Void	set_y_i_sZaGY(AtomicPart, Int);
extern CompositePart	superPart__474Pw(AtomicPart);
extern Void	add_outConnection_C_OlSAX(AtomicPart, Connection);
extern Void	add_inConnection_C_bW7kM(AtomicPart, Connection);
extern Connection	outConnection_i_xzcWk(AtomicPart, Int);
extern Connection	inConnection_i_0pChm(AtomicPart, Int);
extern Void	doNothing__bqiwW(AtomicPart);
extern Void	swapXY__RS84z(AtomicPart);
extern Int	traverse_T_hjOR2(AtomicPart, Traversal);

#ifdef __cplusplus
}
#endif

struct AtomicPart_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__hY8XQ)(AtomicPart);
	Int (*buildDate__EX3oc)(AtomicPart);
	Void (*set_buildDate_i_1rT4n)(AtomicPart, Int);
	java_lang_Object (*otype__bHA9k)(AtomicPart);
	Int (*docId__hLvfd)(AtomicPart);
	Int (*x__cuk3k)(AtomicPart);
	Void (*set_x_i_3rjyY)(AtomicPart, Int);
	Int (*y__bFx3k)(AtomicPart);
	Void (*set_y_i_sZaGY)(AtomicPart, Int);
	CompositePart (*superPart__474Pw)(AtomicPart);
	Void (*add_outConnection_C_OlSAX)(AtomicPart, Connection);
	Void (*add_inConnection_C_bW7kM)(AtomicPart, Connection);
	Connection (*outConnection_i_xzcWk)(AtomicPart, Int);
	Connection (*inConnection_i_0pChm)(AtomicPart, Int);
	Void (*doNothing__bqiwW)(AtomicPart);
	Void (*swapXY__RS84z)(AtomicPart);
	Int (*traverse_T_hjOR2)(AtomicPart, Traversal);
};

struct AtomicPart_bidirectional_DV {

	struct AtomicPart_P_s *AtomicPart_P;
	Void (*init__nsJ0H_)(AtomicPart);
	Void (*init_iiabiiiC_AZ9K8_)(AtomicPart, Int, Int, java_lang_Object, Int, Int, Int, CompositePart);
	Int (*id__hY8XQ_)(AtomicPart);
	Int (*buildDate__EX3oc_)(AtomicPart);
	Void (*set_buildDate_i_1rT4n_)(AtomicPart, Int);
	java_lang_Object (*otype__bHA9k_)(AtomicPart);
	Int (*docId__hLvfd_)(AtomicPart);
	Int (*x__cuk3k_)(AtomicPart);
	Void (*set_x_i_3rjyY_)(AtomicPart, Int);
	Int (*y__bFx3k_)(AtomicPart);
	Void (*set_y_i_sZaGY_)(AtomicPart, Int);
	CompositePart (*superPart__474Pw_)(AtomicPart);
	Void (*add_outConnection_C_OlSAX_)(AtomicPart, Connection);
	Void (*add_inConnection_C_bW7kM_)(AtomicPart, Connection);
	Connection (*outConnection_i_xzcWk_)(AtomicPart, Int);
	Connection (*inConnection_i_0pChm_)(AtomicPart, Int);
	Void (*doNothing__bqiwW_)(AtomicPart);
	Void (*swapXY__RS84z_)(AtomicPart);
	Int (*traverse_T_hjOR2_)(AtomicPart, Traversal);

	struct DesignObj_P_s *DesignObj_P;
	Void (*init__wdMWi_)(DesignObj);
	Int (*id__ipnn9_)(DesignObj);
	Int (*buildDate__xUkLN_)(DesignObj);
	Void (*set_buildDate_i_eM690_)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR_)(DesignObj);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__hY8XQ)(AtomicPart);
	Int (*buildDate__EX3oc)(AtomicPart);
	Void (*set_buildDate_i_1rT4n)(AtomicPart, Int);
	java_lang_Object (*otype__bHA9k)(AtomicPart);
	Int (*docId__hLvfd)(AtomicPart);
	Int (*x__cuk3k)(AtomicPart);
	Void (*set_x_i_3rjyY)(AtomicPart, Int);
	Int (*y__bFx3k)(AtomicPart);
	Void (*set_y_i_sZaGY)(AtomicPart, Int);
	CompositePart (*superPart__474Pw)(AtomicPart);
	Void (*add_outConnection_C_OlSAX)(AtomicPart, Connection);
	Void (*add_inConnection_C_bW7kM)(AtomicPart, Connection);
	Connection (*outConnection_i_xzcWk)(AtomicPart, Int);
	Connection (*inConnection_i_0pChm)(AtomicPart, Int);
	Void (*doNothing__bqiwW)(AtomicPart);
	Void (*swapXY__RS84z)(AtomicPart);
	Int (*traverse_T_hjOR2)(AtomicPart, Traversal);
};

struct AtomicPart_static_DV {

	struct DV_hdr_s hdr;

};

struct AtomicPart_static_bidirectional_DV {
	struct AtomicPart_P_s *AtomicPart_P;

	struct DV_hdr_s hdr;

};

struct AtomicPart_P_s {
	struct Class_s *CompositePart_V;
	struct Class_s *CompositePart_static_V;
	struct Class_s *Connection_V;
	struct Class_s *Connection_static_V;
	struct Class_s *AtomicPart_V;
	struct Class_s *AtomicPart_static_V;
	struct Class_s *DesignObj_V;
	struct Class_s *DesignObj_static_V;
	struct Class_s *OO7_Creator_V;
	struct Class_s *OO7_Creator_static_V;
	struct Class_s *Traversal_V;
	struct Class_s *Traversal_static_V;
	struct Class_s *intset_V;
	struct Class_s *intset_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct AtomicPart_f_s {
	struct Fields_s inh;
	Int th_id_;
	Int th_buildDate_;
	Int th_docId_;
	Int th_x_;
	Int th_y_;
	Shortp th_otype_;
	Shortp th_super_;
	Shortp th_from_;
	Shortp th_to_;
	Int th_from_i;
	Int th_to_i;
};

struct AtomicPart_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *AtomicPart_V;
extern struct Class_s *AtomicPart_static_V;
extern struct AtomicPart_P_s *AtomicPart_P;

#endif /* AtomicPart_H */
/*  BaseAssembly.externs.h -- from Java class BaseAssembly  */
/*  created by Toba  */

#ifndef BaseAssembly_EXTERNS_H
#define BaseAssembly_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_BaseAssembly();

#ifdef __cplusplus
}
#endif

extern struct Class_s *BaseAssembly_V;
extern struct Class_s *BaseAssembly_static_V;

#endif /* BaseAssembly_EXTERNS_H */
/*  BaseAssembly.h -- from Java class BaseAssembly  */
/*  created by Toba  */

#ifndef BaseAssembly_H
#define BaseAssembly_H

#include "compiler/C/compiler.h"

DECLARE_type(BaseAssembly);
DECLARE_type(BaseAssembly_static);

struct BaseAssembly_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "BaseAssembly.externs.h"
#include "java/builtins/exports/java.h"

#include "Assembly.h"
#include "DesignObj.h"
#include "java_lang_Object.h"
#include "CompositePart.h"
#include "ComplexAssembly.h"
#include "Traversal.h"
#include "OO7_Creator.h"
#include "myUtil.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_iiabC_y2meT(BaseAssembly, Int, Int, java_lang_Object, ComplexAssembly);
extern Int	id__EnOmu(BaseAssembly);
extern Int	buildDate__1181P(BaseAssembly);
extern Void	set_buildDate_i_O32aA(BaseAssembly, Int);
extern java_lang_Object	otype__A14rb(BaseAssembly);
extern Void	init_superAssembly_C_D4aoF(BaseAssembly, ComplexAssembly);
extern ComplexAssembly	superAssembly__w7xbF(BaseAssembly);
extern Int	traverse_T_iHl9S(BaseAssembly, Traversal);
extern Int	traverse_random_T_Y4x6X(BaseAssembly, Traversal);
extern Int	traverse_random_path_T_wGS7I(BaseAssembly, Traversal);
extern Void	add_subPart_C_qFbwM(BaseAssembly, CompositePart);
extern CompositePart	subPart_i_9nfuh(BaseAssembly, Int);

#ifdef __cplusplus
}
#endif

struct BaseAssembly_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__EnOmu)(BaseAssembly);
	Int (*buildDate__1181P)(BaseAssembly);
	Void (*set_buildDate_i_O32aA)(BaseAssembly, Int);
	java_lang_Object (*otype__A14rb)(BaseAssembly);
	Void (*init_superAssembly_C_D4aoF)(BaseAssembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__w7xbF)(BaseAssembly);
	Int (*traverse_T_iHl9S)(BaseAssembly, Traversal);
	Int (*traverse_random_T_Y4x6X)(BaseAssembly, Traversal);
	Int (*traverse_random_path_T_wGS7I)(BaseAssembly, Traversal);
	Void (*add_subPart_C_qFbwM)(BaseAssembly, CompositePart);
	CompositePart (*subPart_i_9nfuh)(BaseAssembly, Int);
};

struct BaseAssembly_bidirectional_DV {

	struct BaseAssembly_P_s *BaseAssembly_P;
	Void (*init_iiabC_y2meT_)(BaseAssembly, Int, Int, java_lang_Object, ComplexAssembly);
	Int (*id__EnOmu_)(BaseAssembly);
	Int (*buildDate__1181P_)(BaseAssembly);
	Void (*set_buildDate_i_O32aA_)(BaseAssembly, Int);
	java_lang_Object (*otype__A14rb_)(BaseAssembly);
	Void (*init_superAssembly_C_D4aoF_)(BaseAssembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__w7xbF_)(BaseAssembly);
	Int (*traverse_T_iHl9S_)(BaseAssembly, Traversal);
	Int (*traverse_random_T_Y4x6X_)(BaseAssembly, Traversal);
	Int (*traverse_random_path_T_wGS7I_)(BaseAssembly, Traversal);
	Void (*add_subPart_C_qFbwM_)(BaseAssembly, CompositePart);
	CompositePart (*subPart_i_9nfuh_)(BaseAssembly, Int);

	struct Assembly_P_s *Assembly_P;
	Void (*init__byJNJ_)(Assembly);
	Void (*init_superAssembly_C_UVr8t_)(Assembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__p0FT8_)(Assembly);
	Int (*traverse_T_H8Gln_)(Assembly, Traversal);
	Int (*traverse_random_T_Xo0Pr_)(Assembly, Traversal);
	Int (*traverse_random_path_T_lV5D1_)(Assembly, Traversal);

	struct DesignObj_P_s *DesignObj_P;
	Void (*init__wdMWi_)(DesignObj);
	Int (*id__ipnn9_)(DesignObj);
	Int (*buildDate__xUkLN_)(DesignObj);
	Void (*set_buildDate_i_eM690_)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR_)(DesignObj);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__EnOmu)(BaseAssembly);
	Int (*buildDate__1181P)(BaseAssembly);
	Void (*set_buildDate_i_O32aA)(BaseAssembly, Int);
	java_lang_Object (*otype__A14rb)(BaseAssembly);
	Void (*init_superAssembly_C_D4aoF)(BaseAssembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__w7xbF)(BaseAssembly);
	Int (*traverse_T_iHl9S)(BaseAssembly, Traversal);
	Int (*traverse_random_T_Y4x6X)(BaseAssembly, Traversal);
	Int (*traverse_random_path_T_wGS7I)(BaseAssembly, Traversal);
	Void (*add_subPart_C_qFbwM)(BaseAssembly, CompositePart);
	CompositePart (*subPart_i_9nfuh)(BaseAssembly, Int);
};

struct BaseAssembly_static_DV {

	struct DV_hdr_s hdr;

};

struct BaseAssembly_static_bidirectional_DV {
	struct BaseAssembly_P_s *BaseAssembly_P;

	struct DV_hdr_s hdr;

};

struct BaseAssembly_P_s {
	struct Class_s *CompositePart_V;
	struct Class_s *CompositePart_static_V;
	struct Class_s *ComplexAssembly_V;
	struct Class_s *ComplexAssembly_static_V;
	struct Class_s *BaseAssembly_V;
	struct Class_s *BaseAssembly_static_V;
	struct Class_s *Assembly_V;
	struct Class_s *Assembly_static_V;
	struct Class_s *OO7_Creator_V;
	struct Class_s *OO7_Creator_static_V;
	struct Class_s *myUtil_V;
	struct Class_s *myUtil_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct BaseAssembly_f_s {
	struct Fields_s inh;
	Int th_id_;
	Int th_buildDate_;
	Shortp th_otype_;
	Shortp th_super_;
	Shortp th_sub_;
	Int th_sub_i;
};

struct BaseAssembly_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *BaseAssembly_V;
extern struct Class_s *BaseAssembly_static_V;
extern struct BaseAssembly_P_s *BaseAssembly_P;

#endif /* BaseAssembly_H */
/*  Calendar_Creator.externs.h -- from Java class Calendar_Creator  */
/*  created by Toba  */

#ifndef Calendar_Creator_EXTERNS_H
#define Calendar_Creator_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Calendar_Creator();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Calendar_Creator_V;
extern struct Class_s *Calendar_Creator_static_V;

#endif /* Calendar_Creator_EXTERNS_H */
/*  Calendar_Creator.h -- from Java class Calendar_Creator  */
/*  created by Toba  */

#ifndef Calendar_Creator_H
#define Calendar_Creator_H

#include "compiler/C/compiler.h"

DECLARE_type(Calendar_Creator);
DECLARE_type(Calendar_Creator_static);

struct Calendar_Creator_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Calendar_Creator.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "Calendar.h"
#include "CalendarDB.h"
#include "java_lang_Integer.h"
#include "java_lang_NumberFormatException.h"
#include "java_util_Vector.h"
#include "java_util_NoSuchElementException.h"
#include "Date.h"
#include "Month.h"
#include "Time.h"
#include "Meeting.h"
#include "Notice.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__QKVMs(Calendar_Creator);
extern Calendar	CreateCalendar__JPIHW(Calendar_Creator);
extern CalendarDB	CreateCalendarDB__N74Kl(Calendar_Creator);
extern Void	test__qm6Df(Calendar_Creator);
extern Date	CreateDate_iii_Qfoht(Calendar_Creator, Int, Int, Int);
extern Time	CreateTime_ii_bs3j6(Calendar_Creator, Int, Int);
extern Meeting	CreateMeeting_SSDDTT_n6lgv(Calendar_Creator, java_lang_String, java_lang_String, Date, Date, Time, Time);
extern Notice	CreateNotice_SSDDi_IZnBx(Calendar_Creator, java_lang_String, java_lang_String, Date, Date, Int);
extern java_lang_String	CreateString_ab_On8rk(Calendar_Creator, java_lang_Object);

#ifdef __cplusplus
}
#endif

struct Calendar_Creator_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Calendar (*CreateCalendar__JPIHW)(Calendar_Creator);
	CalendarDB (*CreateCalendarDB__N74Kl)(Calendar_Creator);
	Void (*test__qm6Df)(Calendar_Creator);
	Date (*CreateDate_iii_Qfoht)(Calendar_Creator, Int, Int, Int);
	Time (*CreateTime_ii_bs3j6)(Calendar_Creator, Int, Int);
	Meeting (*CreateMeeting_SSDDTT_n6lgv)(Calendar_Creator, java_lang_String, java_lang_String, Date, Date, Time, Time);
	Notice (*CreateNotice_SSDDi_IZnBx)(Calendar_Creator, java_lang_String, java_lang_String, Date, Date, Int);
	java_lang_String (*CreateString_ab_On8rk)(Calendar_Creator, java_lang_Object);
};

struct Calendar_Creator_bidirectional_DV {

	struct Calendar_Creator_P_s *Calendar_Creator_P;
	Void (*init__QKVMs_)(Calendar_Creator);
	Calendar (*CreateCalendar__JPIHW_)(Calendar_Creator);
	CalendarDB (*CreateCalendarDB__N74Kl_)(Calendar_Creator);
	Void (*test__qm6Df_)(Calendar_Creator);
	Date (*CreateDate_iii_Qfoht_)(Calendar_Creator, Int, Int, Int);
	Time (*CreateTime_ii_bs3j6_)(Calendar_Creator, Int, Int);
	Meeting (*CreateMeeting_SSDDTT_n6lgv_)(Calendar_Creator, java_lang_String, java_lang_String, Date, Date, Time, Time);
	Notice (*CreateNotice_SSDDi_IZnBx_)(Calendar_Creator, java_lang_String, java_lang_String, Date, Date, Int);
	java_lang_String (*CreateString_ab_On8rk_)(Calendar_Creator, java_lang_Object);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Calendar (*CreateCalendar__JPIHW)(Calendar_Creator);
	CalendarDB (*CreateCalendarDB__N74Kl)(Calendar_Creator);
	Void (*test__qm6Df)(Calendar_Creator);
	Date (*CreateDate_iii_Qfoht)(Calendar_Creator, Int, Int, Int);
	Time (*CreateTime_ii_bs3j6)(Calendar_Creator, Int, Int);
	Meeting (*CreateMeeting_SSDDTT_n6lgv)(Calendar_Creator, java_lang_String, java_lang_String, Date, Date, Time, Time);
	Notice (*CreateNotice_SSDDi_IZnBx)(Calendar_Creator, java_lang_String, java_lang_String, Date, Date, Int);
	java_lang_String (*CreateString_ab_On8rk)(Calendar_Creator, java_lang_Object);
};

struct Calendar_Creator_static_DV {

	struct DV_hdr_s hdr;

};

struct Calendar_Creator_static_bidirectional_DV {
	struct Calendar_Creator_P_s *Calendar_Creator_P;

	struct DV_hdr_s hdr;

};

struct Calendar_Creator_P_s {
	struct Class_s *Calendar_V;
	struct Class_s *Calendar_static_V;
	struct Class_s *CalendarDB_V;
	struct Class_s *CalendarDB_static_V;
	struct Class_s *java_lang_Integer_V;
	struct Class_s *java_lang_Integer_static_V;
	struct Class_s *java_lang_NumberFormatException_V;
	struct Class_s *java_lang_NumberFormatException_static_V;
	struct Class_s *java_util_Vector_V;
	struct Class_s *java_util_Vector_static_V;
	struct Class_s *java_util_NoSuchElementException_V;
	struct Class_s *java_util_NoSuchElementException_static_V;
	struct Class_s *Date_V;
	struct Class_s *Date_static_V;
	struct Class_s *Month_V;
	struct Class_s *Month_static_V;
	struct Class_s *Time_V;
	struct Class_s *Time_static_V;
	struct Class_s *Meeting_V;
	struct Class_s *Meeting_static_V;
	struct Class_s *Notice_V;
	struct Class_s *Notice_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Calendar_Creator_V;
	struct Class_s *Calendar_Creator_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct Calendar_Creator_f_s {
	struct Fields_s inh;
};

struct Calendar_Creator_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Calendar_Creator_V;
extern struct Class_s *Calendar_Creator_static_V;
extern struct Calendar_Creator_P_s *Calendar_Creator_P;

#endif /* Calendar_Creator_H */
/*  CalendarDB.externs.h -- from Java class CalendarDB  */
/*  created by Toba  */

#ifndef CalendarDB_EXTERNS_H
#define CalendarDB_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_CalendarDB();

#ifdef __cplusplus
}
#endif

extern struct Class_s *CalendarDB_V;
extern struct Class_s *CalendarDB_static_V;

#endif /* CalendarDB_EXTERNS_H */
/*  CalendarDB.h -- from Java class CalendarDB  */
/*  created by Toba  */

#ifndef CalendarDB_H
#define CalendarDB_H

#include "compiler/C/compiler.h"

DECLARE_type(CalendarDB);
DECLARE_type(CalendarDB_static);

struct CalendarDB_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "CalendarDB.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "Calendar.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__dsaVt(CalendarDB);
extern Int	numCalendars__zWFsE(CalendarDB);
extern Void	addCalendar_CS_9rc72(CalendarDB, Calendar, java_lang_String);
extern Void	deleteCalendar_i_RIuXo(CalendarDB, Int);
extern Calendar	getCalendar_i_Ryhl4(CalendarDB, Int);
extern Calendar	getCalendar_S_A2LPu(CalendarDB, java_lang_String);
extern java_lang_String	getUid_i_gAGUB(CalendarDB, Int);
extern Boolean	contains_S_kpUA1(CalendarDB, java_lang_String);
extern Void	clinit__WNeZA(CalendarDB_static);

#ifdef __cplusplus
}
#endif

struct CalendarDB_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*numCalendars__zWFsE)(CalendarDB);
	Void (*addCalendar_CS_9rc72)(CalendarDB, Calendar, java_lang_String);
	Void (*deleteCalendar_i_RIuXo)(CalendarDB, Int);
	Calendar (*getCalendar_i_Ryhl4)(CalendarDB, Int);
	Calendar (*getCalendar_S_A2LPu)(CalendarDB, java_lang_String);
	java_lang_String (*getUid_i_gAGUB)(CalendarDB, Int);
	Boolean (*contains_S_kpUA1)(CalendarDB, java_lang_String);
};

struct CalendarDB_bidirectional_DV {

	struct CalendarDB_P_s *CalendarDB_P;
	Void (*init__dsaVt_)(CalendarDB);
	Int (*numCalendars__zWFsE_)(CalendarDB);
	Void (*addCalendar_CS_9rc72_)(CalendarDB, Calendar, java_lang_String);
	Void (*deleteCalendar_i_RIuXo_)(CalendarDB, Int);
	Calendar (*getCalendar_i_Ryhl4_)(CalendarDB, Int);
	Calendar (*getCalendar_S_A2LPu_)(CalendarDB, java_lang_String);
	java_lang_String (*getUid_i_gAGUB_)(CalendarDB, Int);
	Boolean (*contains_S_kpUA1_)(CalendarDB, java_lang_String);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*numCalendars__zWFsE)(CalendarDB);
	Void (*addCalendar_CS_9rc72)(CalendarDB, Calendar, java_lang_String);
	Void (*deleteCalendar_i_RIuXo)(CalendarDB, Int);
	Calendar (*getCalendar_i_Ryhl4)(CalendarDB, Int);
	Calendar (*getCalendar_S_A2LPu)(CalendarDB, java_lang_String);
	java_lang_String (*getUid_i_gAGUB)(CalendarDB, Int);
	Boolean (*contains_S_kpUA1)(CalendarDB, java_lang_String);
};

struct CalendarDB_static_DV {

	struct DV_hdr_s hdr;

	Void (*clinit__WNeZA)(CalendarDB_static);
};

struct CalendarDB_static_bidirectional_DV {
	struct CalendarDB_P_s *CalendarDB_P;

	struct DV_hdr_s hdr;

	Void (*clinit__WNeZA)(CalendarDB_static);
};

struct CalendarDB_P_s {
	struct Class_s *Calendar_V;
	struct Class_s *Calendar_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *CalendarDB_V;
	struct Class_s *CalendarDB_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Object_Array_0_V;
	struct Class_s *Object_Array_1_V;
};

struct CalendarDB_f_s {
	struct Fields_s inh;
	Shortp th_calendars;
	Shortp th_uids;
	Int th_numCalendars;
};

struct CalendarDB_static_f_s {
	struct Fields_s inh;
	Int th_MAX_CALENDARS;
};

extern struct Class_s *CalendarDB_V;
extern struct Class_s *CalendarDB_static_V;
extern struct CalendarDB_P_s *CalendarDB_P;

#endif /* CalendarDB_H */
/*  Calendar.externs.h -- from Java class Calendar  */
/*  created by Toba  */

#ifndef Calendar_EXTERNS_H
#define Calendar_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Calendar();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Calendar_V;
extern struct Class_s *Calendar_static_V;

#endif /* Calendar_EXTERNS_H */
/*  Calendar.h -- from Java class Calendar  */
/*  created by Toba  */

#ifndef Calendar_H
#define Calendar_H

#include "compiler/C/compiler.h"

DECLARE_type(Calendar);
DECLARE_type(Calendar_static);

struct Calendar_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Calendar.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "Item.h"
#include "java_lang_String.h"
#include "Util.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_i_QagE5(Calendar, Int);
extern Int	id__T5S9y(Calendar);
extern Int	numItems__8lyk4(Calendar);
extern Item	getItem_i_bFaGl(Calendar, Int);
extern Void	addItem_I_3UE80(Calendar, Item);
extern Void	deleteItem_i_IsMEA(Calendar, Int);
extern java_lang_String	toFile__yaGQ3(Calendar);
extern java_lang_Object	write__vaGe9(Calendar);
extern Void	clinit__ElHl2(Calendar_static);

#ifdef __cplusplus
}
#endif

struct Calendar_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__T5S9y)(Calendar);
	Int (*numItems__8lyk4)(Calendar);
	Item (*getItem_i_bFaGl)(Calendar, Int);
	Void (*addItem_I_3UE80)(Calendar, Item);
	Void (*deleteItem_i_IsMEA)(Calendar, Int);
	java_lang_String (*toFile__yaGQ3)(Calendar);
	java_lang_Object (*write__vaGe9)(Calendar);
};

struct Calendar_bidirectional_DV {

	struct Calendar_P_s *Calendar_P;
	Void (*init_i_QagE5_)(Calendar, Int);
	Int (*id__T5S9y_)(Calendar);
	Int (*numItems__8lyk4_)(Calendar);
	Item (*getItem_i_bFaGl_)(Calendar, Int);
	Void (*addItem_I_3UE80_)(Calendar, Item);
	Void (*deleteItem_i_IsMEA_)(Calendar, Int);
	java_lang_String (*toFile__yaGQ3_)(Calendar);
	java_lang_Object (*write__vaGe9_)(Calendar);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__T5S9y)(Calendar);
	Int (*numItems__8lyk4)(Calendar);
	Item (*getItem_i_bFaGl)(Calendar, Int);
	Void (*addItem_I_3UE80)(Calendar, Item);
	Void (*deleteItem_i_IsMEA)(Calendar, Int);
	java_lang_String (*toFile__yaGQ3)(Calendar);
	java_lang_Object (*write__vaGe9)(Calendar);
};

struct Calendar_static_DV {

	struct DV_hdr_s hdr;

	Void (*clinit__ElHl2)(Calendar_static);
};

struct Calendar_static_bidirectional_DV {
	struct Calendar_P_s *Calendar_P;

	struct DV_hdr_s hdr;

	Void (*clinit__ElHl2)(Calendar_static);
};

struct Calendar_P_s {
	struct Class_s *Item_V;
	struct Class_s *Item_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Calendar_V;
	struct Class_s *Calendar_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
	struct Class_s *Int_Array_0_V;
	struct Class_s *Int_Array_1_V;
};

struct Calendar_f_s {
	struct Fields_s inh;
	Int th_id;
	Int th_numItems;
	Shortp th_items;
};

struct Calendar_static_f_s {
	struct Fields_s inh;
	Int th_MAX_ITEMS;
};

extern struct Class_s *Calendar_V;
extern struct Class_s *Calendar_static_V;
extern struct Calendar_P_s *Calendar_P;

#endif /* Calendar_H */
/*  ComplexAssembly.externs.h -- from Java class ComplexAssembly  */
/*  created by Toba  */

#ifndef ComplexAssembly_EXTERNS_H
#define ComplexAssembly_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_ComplexAssembly();

#ifdef __cplusplus
}
#endif

extern struct Class_s *ComplexAssembly_V;
extern struct Class_s *ComplexAssembly_static_V;

#endif /* ComplexAssembly_EXTERNS_H */
/*  ComplexAssembly.h -- from Java class ComplexAssembly  */
/*  created by Toba  */

#ifndef ComplexAssembly_H
#define ComplexAssembly_H

#include "compiler/C/compiler.h"

DECLARE_type(ComplexAssembly);
DECLARE_type(ComplexAssembly_static);

struct ComplexAssembly_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "ComplexAssembly.externs.h"
#include "java/builtins/exports/java.h"

#include "Assembly.h"
#include "DesignObj.h"
#include "java_lang_Object.h"
#include "Traversal.h"
#include "OO7_Creator.h"
#include "myUtil.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__VtXeu(ComplexAssembly);
extern Void	init_iiabC_vvOIE(ComplexAssembly, Int, Int, java_lang_Object, ComplexAssembly);
extern Int	id__DRbM5(ComplexAssembly);
extern Int	buildDate__u63xQ(ComplexAssembly);
extern Void	set_buildDate_i_fKTg8(ComplexAssembly, Int);
extern java_lang_Object	otype__Ve6Ia(ComplexAssembly);
extern Void	init_superAssembly_C_eewHk(ComplexAssembly, ComplexAssembly);
extern ComplexAssembly	superAssembly__z1JP6(ComplexAssembly);
extern Int	traverse_T_Tqs0z(ComplexAssembly, Traversal);
extern Int	traverse_random_T_rWX34(ComplexAssembly, Traversal);
extern Int	traverse_random_path_T_9XDFe(ComplexAssembly, Traversal);
extern Void	add_subAssembly_A_sTNEa(ComplexAssembly, Assembly);
extern Assembly	subAssembly_i_1cBof(ComplexAssembly, Int);

#ifdef __cplusplus
}
#endif

struct ComplexAssembly_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__DRbM5)(ComplexAssembly);
	Int (*buildDate__u63xQ)(ComplexAssembly);
	Void (*set_buildDate_i_fKTg8)(ComplexAssembly, Int);
	java_lang_Object (*otype__Ve6Ia)(ComplexAssembly);
	Void (*init_superAssembly_C_eewHk)(ComplexAssembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__z1JP6)(ComplexAssembly);
	Int (*traverse_T_Tqs0z)(ComplexAssembly, Traversal);
	Int (*traverse_random_T_rWX34)(ComplexAssembly, Traversal);
	Int (*traverse_random_path_T_9XDFe)(ComplexAssembly, Traversal);
	Void (*add_subAssembly_A_sTNEa)(ComplexAssembly, Assembly);
	Assembly (*subAssembly_i_1cBof)(ComplexAssembly, Int);
};

struct ComplexAssembly_bidirectional_DV {

	struct ComplexAssembly_P_s *ComplexAssembly_P;
	Void (*init__VtXeu_)(ComplexAssembly);
	Void (*init_iiabC_vvOIE_)(ComplexAssembly, Int, Int, java_lang_Object, ComplexAssembly);
	Int (*id__DRbM5_)(ComplexAssembly);
	Int (*buildDate__u63xQ_)(ComplexAssembly);
	Void (*set_buildDate_i_fKTg8_)(ComplexAssembly, Int);
	java_lang_Object (*otype__Ve6Ia_)(ComplexAssembly);
	Void (*init_superAssembly_C_eewHk_)(ComplexAssembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__z1JP6_)(ComplexAssembly);
	Int (*traverse_T_Tqs0z_)(ComplexAssembly, Traversal);
	Int (*traverse_random_T_rWX34_)(ComplexAssembly, Traversal);
	Int (*traverse_random_path_T_9XDFe_)(ComplexAssembly, Traversal);
	Void (*add_subAssembly_A_sTNEa_)(ComplexAssembly, Assembly);
	Assembly (*subAssembly_i_1cBof_)(ComplexAssembly, Int);

	struct Assembly_P_s *Assembly_P;
	Void (*init__byJNJ_)(Assembly);
	Void (*init_superAssembly_C_UVr8t_)(Assembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__p0FT8_)(Assembly);
	Int (*traverse_T_H8Gln_)(Assembly, Traversal);
	Int (*traverse_random_T_Xo0Pr_)(Assembly, Traversal);
	Int (*traverse_random_path_T_lV5D1_)(Assembly, Traversal);

	struct DesignObj_P_s *DesignObj_P;
	Void (*init__wdMWi_)(DesignObj);
	Int (*id__ipnn9_)(DesignObj);
	Int (*buildDate__xUkLN_)(DesignObj);
	Void (*set_buildDate_i_eM690_)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR_)(DesignObj);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__DRbM5)(ComplexAssembly);
	Int (*buildDate__u63xQ)(ComplexAssembly);
	Void (*set_buildDate_i_fKTg8)(ComplexAssembly, Int);
	java_lang_Object (*otype__Ve6Ia)(ComplexAssembly);
	Void (*init_superAssembly_C_eewHk)(ComplexAssembly, ComplexAssembly);
	ComplexAssembly (*superAssembly__z1JP6)(ComplexAssembly);
	Int (*traverse_T_Tqs0z)(ComplexAssembly, Traversal);
	Int (*traverse_random_T_rWX34)(ComplexAssembly, Traversal);
	Int (*traverse_random_path_T_9XDFe)(ComplexAssembly, Traversal);
	Void (*add_subAssembly_A_sTNEa)(ComplexAssembly, Assembly);
	Assembly (*subAssembly_i_1cBof)(ComplexAssembly, Int);
};

struct ComplexAssembly_static_DV {

	struct DV_hdr_s hdr;

};

struct ComplexAssembly_static_bidirectional_DV {
	struct ComplexAssembly_P_s *ComplexAssembly_P;

	struct DV_hdr_s hdr;

};

struct ComplexAssembly_P_s {
	struct Class_s *ComplexAssembly_V;
	struct Class_s *ComplexAssembly_static_V;
	struct Class_s *Assembly_V;
	struct Class_s *Assembly_static_V;
	struct Class_s *OO7_Creator_V;
	struct Class_s *OO7_Creator_static_V;
	struct Class_s *myUtil_V;
	struct Class_s *myUtil_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Object_Array_0_V;
	struct Class_s *Object_Array_1_V;
};

struct ComplexAssembly_f_s {
	struct Fields_s inh;
	Int th_id_;
	Int th_buildDate_;
	Shortp th_otype_;
	Shortp th_super_;
	Shortp th_sub_;
	Int th_sub_i;
};

struct ComplexAssembly_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *ComplexAssembly_V;
extern struct Class_s *ComplexAssembly_static_V;
extern struct ComplexAssembly_P_s *ComplexAssembly_P;

#endif /* ComplexAssembly_H */
/*  CompositePart.externs.h -- from Java class CompositePart  */
/*  created by Toba  */

#ifndef CompositePart_EXTERNS_H
#define CompositePart_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_CompositePart();

#ifdef __cplusplus
}
#endif

extern struct Class_s *CompositePart_V;
extern struct Class_s *CompositePart_static_V;

#endif /* CompositePart_EXTERNS_H */
/*  CompositePart.h -- from Java class CompositePart  */
/*  created by Toba  */

#ifndef CompositePart_H
#define CompositePart_H

#include "compiler/C/compiler.h"

DECLARE_type(CompositePart);
DECLARE_type(CompositePart_static);

struct CompositePart_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "CompositePart.externs.h"
#include "java/builtins/exports/java.h"

#include "DesignObj.h"
#include "java_lang_Object.h"
#include "AtomicPart.h"
#include "Document.h"
#include "BaseAssembly.h"
#include "Traversal.h"
#include "OO7_Creator.h"
#include "intset.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__vWsmK(CompositePart);
extern Void	init_iiabDA_7uWYz(CompositePart, Int, Int, java_lang_Object, Document, AtomicPart);
extern Int	id__3tccF(CompositePart);
extern Int	buildDate__ug4NI(CompositePart);
extern Void	set_buildDate_i_x1OpS(CompositePart, Int);
extern java_lang_Object	otype__7nTSc(CompositePart);
extern Document	doc__trHv8(CompositePart);
extern Void	add_superAssembly_B_kzIoU(CompositePart, BaseAssembly);
extern BaseAssembly	superAssembly_i_LBPw4(CompositePart, Int);
extern Void	add_subPart_A_Vc0wq(CompositePart, AtomicPart);
extern AtomicPart	subPart_i_ACvhC(CompositePart, Int);
extern Int	traverse_T_3ooCD(CompositePart, Traversal);
extern Int	traverse_random_T_lPJFt(CompositePart, Traversal);

#ifdef __cplusplus
}
#endif

struct CompositePart_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__3tccF)(CompositePart);
	Int (*buildDate__ug4NI)(CompositePart);
	Void (*set_buildDate_i_x1OpS)(CompositePart, Int);
	java_lang_Object (*otype__7nTSc)(CompositePart);
	Document (*doc__trHv8)(CompositePart);
	Void (*add_superAssembly_B_kzIoU)(CompositePart, BaseAssembly);
	BaseAssembly (*superAssembly_i_LBPw4)(CompositePart, Int);
	Void (*add_subPart_A_Vc0wq)(CompositePart, AtomicPart);
	AtomicPart (*subPart_i_ACvhC)(CompositePart, Int);
	Int (*traverse_T_3ooCD)(CompositePart, Traversal);
	Int (*traverse_random_T_lPJFt)(CompositePart, Traversal);
};

struct CompositePart_bidirectional_DV {

	struct CompositePart_P_s *CompositePart_P;
	Void (*init__vWsmK_)(CompositePart);
	Void (*init_iiabDA_7uWYz_)(CompositePart, Int, Int, java_lang_Object, Document, AtomicPart);
	Int (*id__3tccF_)(CompositePart);
	Int (*buildDate__ug4NI_)(CompositePart);
	Void (*set_buildDate_i_x1OpS_)(CompositePart, Int);
	java_lang_Object (*otype__7nTSc_)(CompositePart);
	Document (*doc__trHv8_)(CompositePart);
	Void (*add_superAssembly_B_kzIoU_)(CompositePart, BaseAssembly);
	BaseAssembly (*superAssembly_i_LBPw4_)(CompositePart, Int);
	Void (*add_subPart_A_Vc0wq_)(CompositePart, AtomicPart);
	AtomicPart (*subPart_i_ACvhC_)(CompositePart, Int);
	Int (*traverse_T_3ooCD_)(CompositePart, Traversal);
	Int (*traverse_random_T_lPJFt_)(CompositePart, Traversal);

	struct DesignObj_P_s *DesignObj_P;
	Void (*init__wdMWi_)(DesignObj);
	Int (*id__ipnn9_)(DesignObj);
	Int (*buildDate__xUkLN_)(DesignObj);
	Void (*set_buildDate_i_eM690_)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR_)(DesignObj);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__3tccF)(CompositePart);
	Int (*buildDate__ug4NI)(CompositePart);
	Void (*set_buildDate_i_x1OpS)(CompositePart, Int);
	java_lang_Object (*otype__7nTSc)(CompositePart);
	Document (*doc__trHv8)(CompositePart);
	Void (*add_superAssembly_B_kzIoU)(CompositePart, BaseAssembly);
	BaseAssembly (*superAssembly_i_LBPw4)(CompositePart, Int);
	Void (*add_subPart_A_Vc0wq)(CompositePart, AtomicPart);
	AtomicPart (*subPart_i_ACvhC)(CompositePart, Int);
	Int (*traverse_T_3ooCD)(CompositePart, Traversal);
	Int (*traverse_random_T_lPJFt)(CompositePart, Traversal);
};

struct CompositePart_static_DV {

	struct DV_hdr_s hdr;

};

struct CompositePart_static_bidirectional_DV {
	struct CompositePart_P_s *CompositePart_P;

	struct DV_hdr_s hdr;

};

struct CompositePart_P_s {
	struct Class_s *AtomicPart_V;
	struct Class_s *AtomicPart_static_V;
	struct Class_s *Document_V;
	struct Class_s *Document_static_V;
	struct Class_s *BaseAssembly_V;
	struct Class_s *BaseAssembly_static_V;
	struct Class_s *CompositePart_V;
	struct Class_s *CompositePart_static_V;
	struct Class_s *DesignObj_V;
	struct Class_s *DesignObj_static_V;
	struct Class_s *OO7_Creator_V;
	struct Class_s *OO7_Creator_static_V;
	struct Class_s *Traversal_V;
	struct Class_s *Traversal_static_V;
	struct Class_s *intset_V;
	struct Class_s *intset_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Object_Array_0_V;
	struct Class_s *Object_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
};

struct CompositePart_f_s {
	struct Fields_s inh;
	Shortp th_rootPart_;
	Int th_id_;
	Int th_buildDate_;
	Shortp th_otype_;
	Shortp th_doc_;
	Shortp th_super_;
	Int th_super_i;
	Shortp th_sub_;
	Int th_sub_i;
};

struct CompositePart_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *CompositePart_V;
extern struct Class_s *CompositePart_static_V;
extern struct CompositePart_P_s *CompositePart_P;

#endif /* CompositePart_H */
/*  Connection.externs.h -- from Java class Connection  */
/*  created by Toba  */

#ifndef Connection_EXTERNS_H
#define Connection_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Connection();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Connection_V;
extern struct Class_s *Connection_static_V;

#endif /* Connection_EXTERNS_H */
/*  Connection.h -- from Java class Connection  */
/*  created by Toba  */

#ifndef Connection_H
#define Connection_H

#include "compiler/C/compiler.h"

DECLARE_type(Connection);
DECLARE_type(Connection_static);

struct Connection_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Connection.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "AtomicPart.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_abiAA_Z30pp(Connection, java_lang_Object, Int, AtomicPart, AtomicPart);
extern java_lang_Object	otype__RUqFz(Connection);
extern Int	length__0LMQr(Connection);
extern AtomicPart	from__iGiVE(Connection);
extern AtomicPart	to__5MgHb(Connection);

#ifdef __cplusplus
}
#endif

struct Connection_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_Object (*otype__RUqFz)(Connection);
	Int (*length__0LMQr)(Connection);
	AtomicPart (*from__iGiVE)(Connection);
	AtomicPart (*to__5MgHb)(Connection);
};

struct Connection_bidirectional_DV {

	struct Connection_P_s *Connection_P;
	Void (*init_abiAA_Z30pp_)(Connection, java_lang_Object, Int, AtomicPart, AtomicPart);
	java_lang_Object (*otype__RUqFz_)(Connection);
	Int (*length__0LMQr_)(Connection);
	AtomicPart (*from__iGiVE_)(Connection);
	AtomicPart (*to__5MgHb_)(Connection);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_Object (*otype__RUqFz)(Connection);
	Int (*length__0LMQr)(Connection);
	AtomicPart (*from__iGiVE)(Connection);
	AtomicPart (*to__5MgHb)(Connection);
};

struct Connection_static_DV {

	struct DV_hdr_s hdr;

};

struct Connection_static_bidirectional_DV {
	struct Connection_P_s *Connection_P;

	struct DV_hdr_s hdr;

};

struct Connection_P_s {
	struct Class_s *AtomicPart_V;
	struct Class_s *AtomicPart_static_V;
	struct Class_s *Connection_V;
	struct Class_s *Connection_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct Connection_f_s {
	struct Fields_s inh;
	Shortp th_otype_;
	Int th_length_;
	Shortp th_from_;
	Shortp th_to_;
};

struct Connection_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Connection_V;
extern struct Class_s *Connection_static_V;
extern struct Connection_P_s *Connection_P;

#endif /* Connection_H */
/*  Date.externs.h -- from Java class Date  */
/*  created by Toba  */

#ifndef Date_EXTERNS_H
#define Date_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Date();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Date_V;
extern struct Class_s *Date_static_V;

#endif /* Date_EXTERNS_H */
/*  Date.h -- from Java class Date  */
/*  created by Toba  */

#ifndef Date_H
#define Date_H

#include "compiler/C/compiler.h"

DECLARE_type(Date);
DECLARE_type(Date_static);

struct Date_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Date.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "Month.h"
#include "java_lang_String.h"
#include "Util.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__HIDyP(Date);
extern Void	init_iMi_UXhqd(Date, Int, Month, Int);
extern java_lang_String	toString__XVXCN(Date);
extern java_lang_Object	write__1RNdR(Date);
extern Boolean	equals_D_JmoMr(Date, Date);

#ifdef __cplusplus
}
#endif

struct Date_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__XVXCN)(Date);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_Object (*write__1RNdR)(Date);
	Boolean (*equals_D_JmoMr)(Date, Date);
};

struct Date_bidirectional_DV {

	struct Date_P_s *Date_P;
	Void (*init__HIDyP_)(Date);
	Void (*init_iMi_UXhqd_)(Date, Int, Month, Int);
	java_lang_String (*toString__XVXCN_)(Date);
	java_lang_Object (*write__1RNdR_)(Date);
	Boolean (*equals_D_JmoMr_)(Date, Date);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__XVXCN)(Date);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_Object (*write__1RNdR)(Date);
	Boolean (*equals_D_JmoMr)(Date, Date);
};

struct Date_static_DV {

	struct DV_hdr_s hdr;

};

struct Date_static_bidirectional_DV {
	struct Date_P_s *Date_P;

	struct DV_hdr_s hdr;

};

struct Date_P_s {
	struct Class_s *Month_V;
	struct Class_s *Month_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Date_V;
	struct Class_s *Date_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
};

struct Date_f_s {
	struct Fields_s inh;
	Int th_day;
	Int th_year;
	Shortp th_month;
};

struct Date_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Date_V;
extern struct Class_s *Date_static_V;
extern struct Date_P_s *Date_P;

#endif /* Date_H */
/*  DesignObj.externs.h -- from Java class DesignObj  */
/*  created by Toba  */

#ifndef DesignObj_EXTERNS_H
#define DesignObj_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_DesignObj();

#ifdef __cplusplus
}
#endif

extern struct Class_s *DesignObj_V;
extern struct Class_s *DesignObj_static_V;

#endif /* DesignObj_EXTERNS_H */
/*  DesignObj.h -- from Java class DesignObj  */
/*  created by Toba  */

#ifndef DesignObj_H
#define DesignObj_H

#include "compiler/C/compiler.h"

DECLARE_type(DesignObj);
DECLARE_type(DesignObj_static);

struct DesignObj_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "DesignObj.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__wdMWi(DesignObj);
extern Int	id__ipnn9(DesignObj);
extern Int	buildDate__xUkLN(DesignObj);
extern Void	set_buildDate_i_eM690(DesignObj, Int);
extern java_lang_Object	otype__CPNCR(DesignObj);

#ifdef __cplusplus
}
#endif

struct DesignObj_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__ipnn9)(DesignObj);
	Int (*buildDate__xUkLN)(DesignObj);
	Void (*set_buildDate_i_eM690)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR)(DesignObj);
};

struct DesignObj_bidirectional_DV {

	struct DesignObj_P_s *DesignObj_P;
	Void (*init__wdMWi_)(DesignObj);
	Int (*id__ipnn9_)(DesignObj);
	Int (*buildDate__xUkLN_)(DesignObj);
	Void (*set_buildDate_i_eM690_)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR_)(DesignObj);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__ipnn9)(DesignObj);
	Int (*buildDate__xUkLN)(DesignObj);
	Void (*set_buildDate_i_eM690)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR)(DesignObj);
};

struct DesignObj_static_DV {

	struct DV_hdr_s hdr;

};

struct DesignObj_static_bidirectional_DV {
	struct DesignObj_P_s *DesignObj_P;

	struct DV_hdr_s hdr;

};

struct DesignObj_P_s {
	struct Class_s *DesignObj_V;
	struct Class_s *DesignObj_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct DesignObj_f_s {
	struct Fields_s inh;
};

struct DesignObj_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *DesignObj_V;
extern struct Class_s *DesignObj_static_V;
extern struct DesignObj_P_s *DesignObj_P;

#endif /* DesignObj_H */
/*  Document.externs.h -- from Java class Document  */
/*  created by Toba  */

#ifndef Document_EXTERNS_H
#define Document_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Document();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Document_V;
extern struct Class_s *Document_static_V;

#endif /* Document_EXTERNS_H */
/*  Document.h -- from Java class Document  */
/*  created by Toba  */

#ifndef Document_H
#define Document_H

#include "compiler/C/compiler.h"

DECLARE_type(Document);
DECLARE_type(Document_static);

struct Document_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Document.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "CompositePart.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_iabaabC_bKzDU(Document, Int, java_lang_Object, java_lang_Object, CompositePart);
extern Int	docId__Gl9dv(Document);
extern java_lang_Object	title__nO3Cl(Document);
extern java_lang_Object	text__TjiqD(Document);
extern CompositePart	part__CN7BA(Document);
extern Void	init_part_C_VgK7m(Document, CompositePart);

#ifdef __cplusplus
}
#endif

struct Document_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*docId__Gl9dv)(Document);
	java_lang_Object (*title__nO3Cl)(Document);
	java_lang_Object (*text__TjiqD)(Document);
	CompositePart (*part__CN7BA)(Document);
	Void (*init_part_C_VgK7m)(Document, CompositePart);
};

struct Document_bidirectional_DV {

	struct Document_P_s *Document_P;
	Void (*init_iabaabC_bKzDU_)(Document, Int, java_lang_Object, java_lang_Object, CompositePart);
	Int (*docId__Gl9dv_)(Document);
	java_lang_Object (*title__nO3Cl_)(Document);
	java_lang_Object (*text__TjiqD_)(Document);
	CompositePart (*part__CN7BA_)(Document);
	Void (*init_part_C_VgK7m_)(Document, CompositePart);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*docId__Gl9dv)(Document);
	java_lang_Object (*title__nO3Cl)(Document);
	java_lang_Object (*text__TjiqD)(Document);
	CompositePart (*part__CN7BA)(Document);
	Void (*init_part_C_VgK7m)(Document, CompositePart);
};

struct Document_static_DV {

	struct DV_hdr_s hdr;

};

struct Document_static_bidirectional_DV {
	struct Document_P_s *Document_P;

	struct DV_hdr_s hdr;

};

struct Document_P_s {
	struct Class_s *CompositePart_V;
	struct Class_s *CompositePart_static_V;
	struct Class_s *Document_V;
	struct Class_s *Document_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct Document_f_s {
	struct Fields_s inh;
	Int th_docId_;
	Shortp th_title_;
	Shortp th_text_;
	Shortp th_part_;
};

struct Document_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Document_V;
extern struct Class_s *Document_static_V;
extern struct Document_P_s *Document_P;

#endif /* Document_H */
/*  intset.externs.h -- from Java class intset  */
/*  created by Toba  */

#ifndef intset_EXTERNS_H
#define intset_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_intset();

#ifdef __cplusplus
}
#endif

extern struct Class_s *intset_V;
extern struct Class_s *intset_static_V;

#endif /* intset_EXTERNS_H */
/*  intset.h -- from Java class intset  */
/*  created by Toba  */

#ifndef intset_H
#define intset_H

#include "compiler/C/compiler.h"

DECLARE_type(intset);
DECLARE_type(intset_static);

struct intset_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "intset.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_i_B2xLF(intset, Int);
extern Void	insert_i_uzZjP(intset, Int);
extern Boolean	member_i_J16wb(intset, Int);
extern Boolean	empty__7bOaO(intset);
extern Int	size__yHsmM(intset);
extern Void	clear__vXP5z(intset);
extern Int	find_index_i_MXwGm(intset, Int);

#ifdef __cplusplus
}
#endif

struct intset_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*insert_i_uzZjP)(intset, Int);
	Boolean (*member_i_J16wb)(intset, Int);
	Boolean (*empty__7bOaO)(intset);
	Int (*size__yHsmM)(intset);
	Void (*clear__vXP5z)(intset);
	Int (*find_index_i_MXwGm)(intset, Int);
};

struct intset_bidirectional_DV {

	struct intset_P_s *intset_P;
	Void (*init_i_B2xLF_)(intset, Int);
	Void (*insert_i_uzZjP_)(intset, Int);
	Boolean (*member_i_J16wb_)(intset, Int);
	Boolean (*empty__7bOaO_)(intset);
	Int (*size__yHsmM_)(intset);
	Void (*clear__vXP5z_)(intset);
	Int (*find_index_i_MXwGm_)(intset, Int);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*insert_i_uzZjP)(intset, Int);
	Boolean (*member_i_J16wb)(intset, Int);
	Boolean (*empty__7bOaO)(intset);
	Int (*size__yHsmM)(intset);
	Void (*clear__vXP5z)(intset);
	Int (*find_index_i_MXwGm)(intset, Int);
};

struct intset_static_DV {

	struct DV_hdr_s hdr;

};

struct intset_static_bidirectional_DV {
	struct intset_P_s *intset_P;

	struct DV_hdr_s hdr;

};

struct intset_P_s {
	struct Class_s *intset_V;
	struct Class_s *intset_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Int_Array_0_V;
	struct Class_s *Int_Array_1_V;
};

struct intset_f_s {
	struct Fields_s inh;
	Shortp th_slots;
	Int th_m;
	Int th_num_elems;
};

struct intset_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *intset_V;
extern struct Class_s *intset_static_V;
extern struct intset_P_s *intset_P;

#endif /* intset_H */
/*  Item.externs.h -- from Java class Item  */
/*  created by Toba  */

#ifndef Item_EXTERNS_H
#define Item_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Item();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Item_V;
extern struct Class_s *Item_static_V;

#endif /* Item_EXTERNS_H */
/*  Item.h -- from Java class Item  */
/*  created by Toba  */

#ifndef Item_H
#define Item_H

#include "compiler/C/compiler.h"

DECLARE_type(Item);
DECLARE_type(Item_static);

struct Item_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Item.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "Date.h"
#include "Util.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_SS_kc5aC(Item, java_lang_String, java_lang_String);
extern Void	init_SSDD_C4nTP(Item, java_lang_String, java_lang_String, Date, Date);
extern java_lang_String	name__l8fXo(Item);
extern java_lang_String	description__6FG4o(Item);
extern Date	start__pFEMI(Item);
extern Date	finish__y6rtU(Item);
extern java_lang_Object	write__ke04G(Item);
extern java_lang_String	toString__y21AC(Item);

#ifdef __cplusplus
}
#endif

struct Item_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__y21AC)(Item);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__ke04G)(Item);
};

struct Item_bidirectional_DV {

	struct Item_P_s *Item_P;
	Void (*init_SS_kc5aC_)(Item, java_lang_String, java_lang_String);
	Void (*init_SSDD_C4nTP_)(Item, java_lang_String, java_lang_String, Date, Date);
	java_lang_String (*name__l8fXo_)(Item);
	java_lang_String (*description__6FG4o_)(Item);
	Date (*start__pFEMI_)(Item);
	Date (*finish__y6rtU_)(Item);
	java_lang_Object (*write__ke04G_)(Item);
	java_lang_String (*toString__y21AC_)(Item);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__y21AC)(Item);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__ke04G)(Item);
};

struct Item_static_DV {

	struct DV_hdr_s hdr;

};

struct Item_static_bidirectional_DV {
	struct Item_P_s *Item_P;

	struct DV_hdr_s hdr;

};

struct Item_P_s {
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Date_V;
	struct Class_s *Date_static_V;
	struct Class_s *Item_V;
	struct Class_s *Item_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
};

struct Item_f_s {
	struct Fields_s inh;
	Shortp th_name;
	Shortp th_description;
	Shortp th_start;
	Shortp th_finish;
};

struct Item_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Item_V;
extern struct Class_s *Item_static_V;
extern struct Item_P_s *Item_P;

#endif /* Item_H */
/*  Manual.externs.h -- from Java class Manual  */
/*  created by Toba  */

#ifndef Manual_EXTERNS_H
#define Manual_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Manual();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Manual_V;
extern struct Class_s *Manual_static_V;

#endif /* Manual_EXTERNS_H */
/*  Manual.h -- from Java class Manual  */
/*  created by Toba  */

#ifndef Manual_H
#define Manual_H

#include "compiler/C/compiler.h"

DECLARE_type(Manual);
DECLARE_type(Manual_static);

struct Manual_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Manual.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "OO7Module.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_iabaab_dMW6K(Manual, Int, java_lang_Object, java_lang_Object);
extern Int	docId__5HTYW(Manual);
extern java_lang_Object	title__Ar1Nl(Manual);
extern java_lang_Object	text__Aqq2S(Manual);
extern OO7Module	mod__hajnv(Manual);
extern Void	init_mod_O_Y1qZn(Manual, OO7Module);

#ifdef __cplusplus
}
#endif

struct Manual_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*docId__5HTYW)(Manual);
	java_lang_Object (*title__Ar1Nl)(Manual);
	java_lang_Object (*text__Aqq2S)(Manual);
	OO7Module (*mod__hajnv)(Manual);
	Void (*init_mod_O_Y1qZn)(Manual, OO7Module);
};

struct Manual_bidirectional_DV {

	struct Manual_P_s *Manual_P;
	Void (*init_iabaab_dMW6K_)(Manual, Int, java_lang_Object, java_lang_Object);
	Int (*docId__5HTYW_)(Manual);
	java_lang_Object (*title__Ar1Nl_)(Manual);
	java_lang_Object (*text__Aqq2S_)(Manual);
	OO7Module (*mod__hajnv_)(Manual);
	Void (*init_mod_O_Y1qZn_)(Manual, OO7Module);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*docId__5HTYW)(Manual);
	java_lang_Object (*title__Ar1Nl)(Manual);
	java_lang_Object (*text__Aqq2S)(Manual);
	OO7Module (*mod__hajnv)(Manual);
	Void (*init_mod_O_Y1qZn)(Manual, OO7Module);
};

struct Manual_static_DV {

	struct DV_hdr_s hdr;

};

struct Manual_static_bidirectional_DV {
	struct Manual_P_s *Manual_P;

	struct DV_hdr_s hdr;

};

struct Manual_P_s {
	struct Class_s *OO7Module_V;
	struct Class_s *OO7Module_static_V;
	struct Class_s *Manual_V;
	struct Class_s *Manual_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct Manual_f_s {
	struct Fields_s inh;
	Int th_docId_;
	Shortp th_title_;
	Shortp th_text_;
	Shortp th_mod_;
};

struct Manual_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Manual_V;
extern struct Class_s *Manual_static_V;
extern struct Manual_P_s *Manual_P;

#endif /* Manual_H */
/*  Meeting.externs.h -- from Java class Meeting  */
/*  created by Toba  */

#ifndef Meeting_EXTERNS_H
#define Meeting_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Meeting();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Meeting_V;
extern struct Class_s *Meeting_static_V;

#endif /* Meeting_EXTERNS_H */
/*  Meeting.h -- from Java class Meeting  */
/*  created by Toba  */

#ifndef Meeting_H
#define Meeting_H

#include "compiler/C/compiler.h"

DECLARE_type(Meeting);
DECLARE_type(Meeting_static);

struct Meeting_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Meeting.externs.h"
#include "java/builtins/exports/java.h"

#include "Item.h"
#include "java_lang_Object.h"
#include "Time.h"
#include "java_lang_String.h"
#include "Date.h"
#include "Util.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_SS_SfLH4(Meeting, java_lang_String, java_lang_String);
extern Void	init_SSDDTT_COGix(Meeting, java_lang_String, java_lang_String, Date, Date, Time, Time);
extern Time	startTime__hjiyk(Meeting);
extern Time	endTime__c80Yw(Meeting);
extern Int	length__DSeZr(Meeting);
extern java_lang_Object	write__a5huP(Meeting);
extern java_lang_String	toString__O2sgv(Meeting);

#ifdef __cplusplus
}
#endif

struct Meeting_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__O2sgv)(Meeting);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__a5huP)(Meeting);
	Time (*startTime__hjiyk)(Meeting);
	Time (*endTime__c80Yw)(Meeting);
	Int (*length__DSeZr)(Meeting);
};

struct Meeting_bidirectional_DV {

	struct Meeting_P_s *Meeting_P;
	Void (*init_SS_SfLH4_)(Meeting, java_lang_String, java_lang_String);
	Void (*init_SSDDTT_COGix_)(Meeting, java_lang_String, java_lang_String, Date, Date, Time, Time);
	Time (*startTime__hjiyk_)(Meeting);
	Time (*endTime__c80Yw_)(Meeting);
	Int (*length__DSeZr_)(Meeting);
	java_lang_Object (*write__a5huP_)(Meeting);
	java_lang_String (*toString__O2sgv_)(Meeting);

	struct Item_P_s *Item_P;
	Void (*init_SS_kc5aC_)(Item, java_lang_String, java_lang_String);
	Void (*init_SSDD_C4nTP_)(Item, java_lang_String, java_lang_String, Date, Date);
	java_lang_String (*name__l8fXo_)(Item);
	java_lang_String (*description__6FG4o_)(Item);
	Date (*start__pFEMI_)(Item);
	Date (*finish__y6rtU_)(Item);
	java_lang_Object (*write__ke04G_)(Item);
	java_lang_String (*toString__y21AC_)(Item);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__O2sgv)(Meeting);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__a5huP)(Meeting);
	Time (*startTime__hjiyk)(Meeting);
	Time (*endTime__c80Yw)(Meeting);
	Int (*length__DSeZr)(Meeting);
};

struct Meeting_static_DV {

	struct DV_hdr_s hdr;

};

struct Meeting_static_bidirectional_DV {
	struct Meeting_P_s *Meeting_P;

	struct DV_hdr_s hdr;

};

struct Meeting_P_s {
	struct Class_s *Time_V;
	struct Class_s *Time_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Meeting_V;
	struct Class_s *Meeting_static_V;
	struct Class_s *Item_V;
	struct Class_s *Item_static_V;
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
};

struct Meeting_f_s {
	struct Fields_s inh;
	Shortp th_name;
	Shortp th_description;
	Shortp th_start;
	Shortp th_finish;
	Shortp th_startTime;
	Shortp th_endTime;
	Int th_length;
};

struct Meeting_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Meeting_V;
extern struct Class_s *Meeting_static_V;
extern struct Meeting_P_s *Meeting_P;

#endif /* Meeting_H */
/*  Month.externs.h -- from Java class Month  */
/*  created by Toba  */

#ifndef Month_EXTERNS_H
#define Month_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Month();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Month_V;
extern struct Class_s *Month_static_V;

#endif /* Month_EXTERNS_H */
/*  Month.h -- from Java class Month  */
/*  created by Toba  */

#ifndef Month_H
#define Month_H

#include "compiler/C/compiler.h"

DECLARE_type(Month);
DECLARE_type(Month_static);

struct Month_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Month.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_i_u6vPa(Month, Int);
extern Month	January__AafNR(Month_static);
extern Month	February__6Iboq(Month_static);
extern Month	March__nRfYn(Month_static);
extern Month	April__YfheE(Month_static);
extern Month	May__jLaG2(Month_static);
extern Month	June__OD0zh(Month_static);
extern Month	July__4Dw85(Month_static);
extern Month	August__x7np0(Month_static);
extern Month	September__LTPwY(Month_static);
extern Month	October__sI7Er(Month_static);
extern Month	November__25Odk(Month_static);
extern Month	December__FgDj0(Month_static);
extern java_lang_String	name__26xZA(Month);
extern java_lang_String	shortName__WmJwU(Month);
extern Boolean	equals_M_z28es(Month, Month);
extern Void	clinit__4Mx5J(Month_static);

#ifdef __cplusplus
}
#endif

struct Month_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__26xZA)(Month);
	java_lang_String (*shortName__WmJwU)(Month);
	Boolean (*equals_M_z28es)(Month, Month);
};

struct Month_bidirectional_DV {

	struct Month_P_s *Month_P;
	Void (*init_i_u6vPa_)(Month, Int);
	java_lang_String (*name__26xZA_)(Month);
	java_lang_String (*shortName__WmJwU_)(Month);
	Boolean (*equals_M_z28es_)(Month, Month);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__26xZA)(Month);
	java_lang_String (*shortName__WmJwU)(Month);
	Boolean (*equals_M_z28es)(Month, Month);
};

struct Month_static_DV {

	struct DV_hdr_s hdr;

	Month (*January__AafNR)(Month_static);
	Month (*February__6Iboq)(Month_static);
	Month (*March__nRfYn)(Month_static);
	Month (*April__YfheE)(Month_static);
	Month (*May__jLaG2)(Month_static);
	Month (*June__OD0zh)(Month_static);
	Month (*July__4Dw85)(Month_static);
	Month (*August__x7np0)(Month_static);
	Month (*September__LTPwY)(Month_static);
	Month (*October__sI7Er)(Month_static);
	Month (*November__25Odk)(Month_static);
	Month (*December__FgDj0)(Month_static);
	Void (*clinit__4Mx5J)(Month_static);
};

struct Month_static_bidirectional_DV {
	struct Month_P_s *Month_P;

	struct DV_hdr_s hdr;

	Month (*January__AafNR)(Month_static);
	Month (*February__6Iboq)(Month_static);
	Month (*March__nRfYn)(Month_static);
	Month (*April__YfheE)(Month_static);
	Month (*May__jLaG2)(Month_static);
	Month (*June__OD0zh)(Month_static);
	Month (*July__4Dw85)(Month_static);
	Month (*August__x7np0)(Month_static);
	Month (*September__LTPwY)(Month_static);
	Month (*October__sI7Er)(Month_static);
	Month (*November__25Odk)(Month_static);
	Month (*December__FgDj0)(Month_static);
	Void (*clinit__4Mx5J)(Month_static);
};

struct Month_P_s {
	struct Class_s *Month_V;
	struct Class_s *Month_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Object_Array_0_V;
	struct Class_s *Object_Array_1_V;
};

struct Month_f_s {
	struct Fields_s inh;
	Int th_rep;
};

struct Month_static_f_s {
	struct Fields_s inh;
	Shortp th_names;
	Shortp th_shortNames;
};

extern struct Class_s *Month_V;
extern struct Class_s *Month_static_V;
extern struct Month_P_s *Month_P;

#endif /* Month_H */
/*  myUtil.externs.h -- from Java class myUtil  */
/*  created by Toba  */

#ifndef myUtil_EXTERNS_H
#define myUtil_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_myUtil();

#ifdef __cplusplus
}
#endif

extern struct Class_s *myUtil_V;
extern struct Class_s *myUtil_static_V;

#endif /* myUtil_EXTERNS_H */
/*  myUtil.h -- from Java class myUtil  */
/*  created by Toba  */

#ifndef myUtil_H
#define myUtil_H

#include "compiler/C/compiler.h"

DECLARE_type(myUtil);
DECLARE_type(myUtil_static);

struct myUtil_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "myUtil.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__32HNf(myUtil);
extern Int	rand_int__H86dJ(myUtil_static);
extern Void	clinit__WAD38(myUtil_static);

#ifdef __cplusplus
}
#endif

struct myUtil_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
};

struct myUtil_bidirectional_DV {

	struct myUtil_P_s *myUtil_P;
	Void (*init__32HNf_)(myUtil);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
};

struct myUtil_static_DV {

	struct DV_hdr_s hdr;

	Int (*rand_int__H86dJ)(myUtil_static);
	Void (*clinit__WAD38)(myUtil_static);
};

struct myUtil_static_bidirectional_DV {
	struct myUtil_P_s *myUtil_P;

	struct DV_hdr_s hdr;

	Int (*rand_int__H86dJ)(myUtil_static);
	Void (*clinit__WAD38)(myUtil_static);
};

struct myUtil_P_s {
	struct Class_s *myUtil_V;
	struct Class_s *myUtil_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct myUtil_f_s {
	struct Fields_s inh;
};

struct myUtil_static_f_s {
	struct Fields_s inh;
	Int th_multiplier;
	Int th_addend;
	Int th_mask;
	Int th_seed;
};

extern struct Class_s *myUtil_V;
extern struct Class_s *myUtil_static_V;
extern struct myUtil_P_s *myUtil_P;

#endif /* myUtil_H */
/*  Notice.externs.h -- from Java class Notice  */
/*  created by Toba  */

#ifndef Notice_EXTERNS_H
#define Notice_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Notice();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Notice_V;
extern struct Class_s *Notice_static_V;

#endif /* Notice_EXTERNS_H */
/*  Notice.h -- from Java class Notice  */
/*  created by Toba  */

#ifndef Notice_H
#define Notice_H

#include "compiler/C/compiler.h"

DECLARE_type(Notice);
DECLARE_type(Notice_static);

struct Notice_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Notice.externs.h"
#include "java/builtins/exports/java.h"

#include "Item.h"
#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "Date.h"
#include "Util.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_SSi_knWUd(Notice, java_lang_String, java_lang_String, Int);
extern Void	init_SSDDi_uLENn(Notice, java_lang_String, java_lang_String, Date, Date, Int);
extern Int	length__sYeRd(Notice);
extern java_lang_Object	write__rX3n5(Notice);
extern java_lang_String	toString__f2Ayc(Notice);

#ifdef __cplusplus
}
#endif

struct Notice_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__f2Ayc)(Notice);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__rX3n5)(Notice);
	Int (*length__sYeRd)(Notice);
};

struct Notice_bidirectional_DV {

	struct Notice_P_s *Notice_P;
	Void (*init_SSi_knWUd_)(Notice, java_lang_String, java_lang_String, Int);
	Void (*init_SSDDi_uLENn_)(Notice, java_lang_String, java_lang_String, Date, Date, Int);
	Int (*length__sYeRd_)(Notice);
	java_lang_Object (*write__rX3n5_)(Notice);
	java_lang_String (*toString__f2Ayc_)(Notice);

	struct Item_P_s *Item_P;
	Void (*init_SS_kc5aC_)(Item, java_lang_String, java_lang_String);
	Void (*init_SSDD_C4nTP_)(Item, java_lang_String, java_lang_String, Date, Date);
	java_lang_String (*name__l8fXo_)(Item);
	java_lang_String (*description__6FG4o_)(Item);
	Date (*start__pFEMI_)(Item);
	Date (*finish__y6rtU_)(Item);
	java_lang_Object (*write__ke04G_)(Item);
	java_lang_String (*toString__y21AC_)(Item);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__f2Ayc)(Notice);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__rX3n5)(Notice);
	Int (*length__sYeRd)(Notice);
};

struct Notice_static_DV {

	struct DV_hdr_s hdr;

};

struct Notice_static_bidirectional_DV {
	struct Notice_P_s *Notice_P;

	struct DV_hdr_s hdr;

};

struct Notice_P_s {
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Notice_V;
	struct Class_s *Notice_static_V;
	struct Class_s *Item_V;
	struct Class_s *Item_static_V;
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
};

struct Notice_f_s {
	struct Fields_s inh;
	Shortp th_name;
	Shortp th_description;
	Shortp th_start;
	Shortp th_finish;
	Int th_length;
};

struct Notice_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Notice_V;
extern struct Class_s *Notice_static_V;
extern struct Notice_P_s *Notice_P;

#endif /* Notice_H */
/*  OO7_Creator.externs.h -- from Java class OO7_Creator  */
/*  created by Toba  */

#ifndef OO7_Creator_EXTERNS_H
#define OO7_Creator_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_OO7_Creator();

#ifdef __cplusplus
}
#endif

extern struct Class_s *OO7_Creator_V;
extern struct Class_s *OO7_Creator_static_V;

#endif /* OO7_Creator_EXTERNS_H */
/*  OO7_Creator.h -- from Java class OO7_Creator  */
/*  created by Toba  */

#ifndef OO7_Creator_H
#define OO7_Creator_H

#include "compiler/C/compiler.h"

DECLARE_type(OO7_Creator);
DECLARE_type(OO7_Creator_static);

struct OO7_Creator_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "OO7_Creator.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "OO7DB.h"
#include "Manual.h"
#include "ComplexAssembly.h"
#include "OO7Module.h"
#include "BaseAssembly.h"
#include "AtomicPart.h"
#include "CompositePart.h"
#include "Document.h"
#include "java_lang_RuntimeException.h"
#include "Connection.h"
#include "Assembly.h"
#include "myUtil.h"
#include "thor_Thor.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__h2Mf2(OO7_Creator);
extern Void	set_medium__FDsNA(OO7_Creator);
extern Void	set_large__bhVsJ(OO7_Creator);
extern OO7DB	DB__XJWw5(OO7_Creator);
extern OO7Module	Module__V0bPz(OO7_Creator);
extern Assembly	Assemblies_iC_q9qVn(OO7_Creator, Int, ComplexAssembly);
extern Void	Composites_O_N1WsR(OO7_Creator, OO7DB);
extern Void	Composites_AO_uM7hw(OO7_Creator, Assembly, OO7Module);
extern CompositePart	Composite_A_GnRep(OO7_Creator, AtomicPart);
extern java_lang_Object	Atomics_Ci_XzR9a(OO7_Creator, CompositePart, Int);
extern Void	connect_parts_aAii_uW4eB(OO7_Creator, java_lang_Object, Int, Int);
extern Int	next_id__ROUa7(OO7_Creator);
extern java_lang_Object	random_string_i_Q7Wxb(OO7_Creator, Int);
extern java_lang_Object	random_string_array_i_dVGFu(OO7_Creator, Int);
extern Void	clinit__yTpiv(OO7_Creator_static);

#ifdef __cplusplus
}
#endif

struct OO7_Creator_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*set_medium__FDsNA)(OO7_Creator);
	Void (*set_large__bhVsJ)(OO7_Creator);
	OO7DB (*DB__XJWw5)(OO7_Creator);
	OO7Module (*Module__V0bPz)(OO7_Creator);
	Assembly (*Assemblies_iC_q9qVn)(OO7_Creator, Int, ComplexAssembly);
	Void (*Composites_O_N1WsR)(OO7_Creator, OO7DB);
	Void (*Composites_AO_uM7hw)(OO7_Creator, Assembly, OO7Module);
	CompositePart (*Composite_A_GnRep)(OO7_Creator, AtomicPart);
	java_lang_Object (*Atomics_Ci_XzR9a)(OO7_Creator, CompositePart, Int);
	Void (*connect_parts_aAii_uW4eB)(OO7_Creator, java_lang_Object, Int, Int);
	Int (*next_id__ROUa7)(OO7_Creator);
	java_lang_Object (*random_string_i_Q7Wxb)(OO7_Creator, Int);
	java_lang_Object (*random_string_array_i_dVGFu)(OO7_Creator, Int);
};

struct OO7_Creator_bidirectional_DV {

	struct OO7_Creator_P_s *OO7_Creator_P;
	Void (*init__h2Mf2_)(OO7_Creator);
	Void (*set_medium__FDsNA_)(OO7_Creator);
	Void (*set_large__bhVsJ_)(OO7_Creator);
	OO7DB (*DB__XJWw5_)(OO7_Creator);
	OO7Module (*Module__V0bPz_)(OO7_Creator);
	Assembly (*Assemblies_iC_q9qVn_)(OO7_Creator, Int, ComplexAssembly);
	Void (*Composites_O_N1WsR_)(OO7_Creator, OO7DB);
	Void (*Composites_AO_uM7hw_)(OO7_Creator, Assembly, OO7Module);
	CompositePart (*Composite_A_GnRep_)(OO7_Creator, AtomicPart);
	java_lang_Object (*Atomics_Ci_XzR9a_)(OO7_Creator, CompositePart, Int);
	Void (*connect_parts_aAii_uW4eB_)(OO7_Creator, java_lang_Object, Int, Int);
	Int (*next_id__ROUa7_)(OO7_Creator);
	java_lang_Object (*random_string_i_Q7Wxb_)(OO7_Creator, Int);
	java_lang_Object (*random_string_array_i_dVGFu_)(OO7_Creator, Int);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*set_medium__FDsNA)(OO7_Creator);
	Void (*set_large__bhVsJ)(OO7_Creator);
	OO7DB (*DB__XJWw5)(OO7_Creator);
	OO7Module (*Module__V0bPz)(OO7_Creator);
	Assembly (*Assemblies_iC_q9qVn)(OO7_Creator, Int, ComplexAssembly);
	Void (*Composites_O_N1WsR)(OO7_Creator, OO7DB);
	Void (*Composites_AO_uM7hw)(OO7_Creator, Assembly, OO7Module);
	CompositePart (*Composite_A_GnRep)(OO7_Creator, AtomicPart);
	java_lang_Object (*Atomics_Ci_XzR9a)(OO7_Creator, CompositePart, Int);
	Void (*connect_parts_aAii_uW4eB)(OO7_Creator, java_lang_Object, Int, Int);
	Int (*next_id__ROUa7)(OO7_Creator);
	java_lang_Object (*random_string_i_Q7Wxb)(OO7_Creator, Int);
	java_lang_Object (*random_string_array_i_dVGFu)(OO7_Creator, Int);
};

struct OO7_Creator_static_DV {

	struct DV_hdr_s hdr;

	Void (*clinit__yTpiv)(OO7_Creator_static);
};

struct OO7_Creator_static_bidirectional_DV {
	struct OO7_Creator_P_s *OO7_Creator_P;

	struct DV_hdr_s hdr;

	Void (*clinit__yTpiv)(OO7_Creator_static);
};

struct OO7_Creator_P_s {
	struct Class_s *OO7DB_V;
	struct Class_s *OO7DB_static_V;
	struct Class_s *Manual_V;
	struct Class_s *Manual_static_V;
	struct Class_s *ComplexAssembly_V;
	struct Class_s *ComplexAssembly_static_V;
	struct Class_s *OO7Module_V;
	struct Class_s *OO7Module_static_V;
	struct Class_s *BaseAssembly_V;
	struct Class_s *BaseAssembly_static_V;
	struct Class_s *AtomicPart_V;
	struct Class_s *AtomicPart_static_V;
	struct Class_s *CompositePart_V;
	struct Class_s *CompositePart_static_V;
	struct Class_s *Document_V;
	struct Class_s *Document_static_V;
	struct Class_s *java_lang_RuntimeException_V;
	struct Class_s *java_lang_RuntimeException_static_V;
	struct Class_s *Connection_V;
	struct Class_s *Connection_static_V;
	struct Class_s *OO7_Creator_V;
	struct Class_s *OO7_Creator_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *myUtil_V;
	struct Class_s *myUtil_static_V;
	struct Class_s *Assembly_V;
	struct Class_s *Assembly_static_V;
	struct Class_s *thor_Thor_V;
	struct Class_s *thor_Thor_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Object_Array_0_V;
	struct Class_s *Object_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
	struct Class_s *Byte_Array_2_V;
};

struct OO7_Creator_f_s {
	struct Fields_s inh;
	Int th_TitleSize;
	Int th_TypeSize;
};

struct OO7_Creator_static_f_s {
	struct Fields_s inh;
	Int th_NumAtomicPerComp;
	Int th_NumConnPerAtomic;
	Int th_DocumentSize;
	Int th_ManualSize;
	Int th_NumCompPerModule;
	Int th_NumAssmPerAssm;
	Int th_NumAssmLevels;
	Int th_NumCompPerAssm;
	Int th_NumModules;
	Int th_id;
};

extern struct Class_s *OO7_Creator_V;
extern struct Class_s *OO7_Creator_static_V;
extern struct OO7_Creator_P_s *OO7_Creator_P;

#endif /* OO7_Creator_H */
/*  OO7DB.externs.h -- from Java class OO7DB  */
/*  created by Toba  */

#ifndef OO7DB_EXTERNS_H
#define OO7DB_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_OO7DB();

#ifdef __cplusplus
}
#endif

extern struct Class_s *OO7DB_V;
extern struct Class_s *OO7DB_static_V;

#endif /* OO7DB_EXTERNS_H */
/*  OO7DB.h -- from Java class OO7DB  */
/*  created by Toba  */

#ifndef OO7DB_H
#define OO7DB_H

#include "compiler/C/compiler.h"

DECLARE_type(OO7DB);
DECLARE_type(OO7DB_static);

struct OO7DB_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "OO7DB.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "OO7Module.h"
#include "Traversal.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_iiiiiiiii_JbpGX(OO7DB, Int, Int, Int, Int, Int, Int, Int, Int, Int);
extern Void	add_mod_O_QdqSg(OO7DB, OO7Module);
extern OO7Module	mod_i_fPfNu(OO7DB, Int);
extern Int	numAtomicPerComp__4LJik(OO7DB);
extern Int	numConnPerAtomic__dYQt6(OO7DB);
extern Int	documentSize__jVxbD(OO7DB);
extern Int	manualSize__6jsIN(OO7DB);
extern Int	numCompPerModule__PUJLF(OO7DB);
extern Int	numAssmPerAssm__euNq0(OO7DB);
extern Int	numAssmLevels__u2vyk(OO7DB);
extern Int	numCompPerAssm__LFalI(OO7DB);
extern Int	numModules__MKr3I(OO7DB);
extern Int	traverse_i_Ysmy5(OO7DB, Int);

#ifdef __cplusplus
}
#endif

struct OO7DB_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*add_mod_O_QdqSg)(OO7DB, OO7Module);
	OO7Module (*mod_i_fPfNu)(OO7DB, Int);
	Int (*numAtomicPerComp__4LJik)(OO7DB);
	Int (*numConnPerAtomic__dYQt6)(OO7DB);
	Int (*documentSize__jVxbD)(OO7DB);
	Int (*manualSize__6jsIN)(OO7DB);
	Int (*numCompPerModule__PUJLF)(OO7DB);
	Int (*numAssmPerAssm__euNq0)(OO7DB);
	Int (*numAssmLevels__u2vyk)(OO7DB);
	Int (*numCompPerAssm__LFalI)(OO7DB);
	Int (*numModules__MKr3I)(OO7DB);
	Int (*traverse_i_Ysmy5)(OO7DB, Int);
};

struct OO7DB_bidirectional_DV {

	struct OO7DB_P_s *OO7DB_P;
	Void (*init_iiiiiiiii_JbpGX_)(OO7DB, Int, Int, Int, Int, Int, Int, Int, Int, Int);
	Void (*add_mod_O_QdqSg_)(OO7DB, OO7Module);
	OO7Module (*mod_i_fPfNu_)(OO7DB, Int);
	Int (*numAtomicPerComp__4LJik_)(OO7DB);
	Int (*numConnPerAtomic__dYQt6_)(OO7DB);
	Int (*documentSize__jVxbD_)(OO7DB);
	Int (*manualSize__6jsIN_)(OO7DB);
	Int (*numCompPerModule__PUJLF_)(OO7DB);
	Int (*numAssmPerAssm__euNq0_)(OO7DB);
	Int (*numAssmLevels__u2vyk_)(OO7DB);
	Int (*numCompPerAssm__LFalI_)(OO7DB);
	Int (*numModules__MKr3I_)(OO7DB);
	Int (*traverse_i_Ysmy5_)(OO7DB, Int);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*add_mod_O_QdqSg)(OO7DB, OO7Module);
	OO7Module (*mod_i_fPfNu)(OO7DB, Int);
	Int (*numAtomicPerComp__4LJik)(OO7DB);
	Int (*numConnPerAtomic__dYQt6)(OO7DB);
	Int (*documentSize__jVxbD)(OO7DB);
	Int (*manualSize__6jsIN)(OO7DB);
	Int (*numCompPerModule__PUJLF)(OO7DB);
	Int (*numAssmPerAssm__euNq0)(OO7DB);
	Int (*numAssmLevels__u2vyk)(OO7DB);
	Int (*numCompPerAssm__LFalI)(OO7DB);
	Int (*numModules__MKr3I)(OO7DB);
	Int (*traverse_i_Ysmy5)(OO7DB, Int);
};

struct OO7DB_static_DV {

	struct DV_hdr_s hdr;

};

struct OO7DB_static_bidirectional_DV {
	struct OO7DB_P_s *OO7DB_P;

	struct DV_hdr_s hdr;

};

struct OO7DB_P_s {
	struct Class_s *OO7Module_V;
	struct Class_s *OO7Module_static_V;
	struct Class_s *Traversal_V;
	struct Class_s *Traversal_static_V;
	struct Class_s *OO7DB_V;
	struct Class_s *OO7DB_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Object_Array_0_V;
	struct Class_s *Object_Array_1_V;
};

struct OO7DB_f_s {
	struct Fields_s inh;
	Int th_numAtomicPerComp_;
	Int th_numConnPerAtomic_;
	Int th_documentSize_;
	Int th_manualSize_;
	Int th_numCompPerModule_;
	Int th_numAssmPerAssm_;
	Int th_numAssmLevels_;
	Int th_numCompPerAssm_;
	Int th_numModules_;
	Shortp th_modules;
	Int th_modules_i;
};

struct OO7DB_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *OO7DB_V;
extern struct Class_s *OO7DB_static_V;
extern struct OO7DB_P_s *OO7DB_P;

#endif /* OO7DB_H */
/*  OO7Module.externs.h -- from Java class OO7Module  */
/*  created by Toba  */

#ifndef OO7Module_EXTERNS_H
#define OO7Module_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_OO7Module();

#ifdef __cplusplus
}
#endif

extern struct Class_s *OO7Module_V;
extern struct Class_s *OO7Module_static_V;

#endif /* OO7Module_EXTERNS_H */
/*  OO7Module.h -- from Java class OO7Module  */
/*  created by Toba  */

#ifndef OO7Module_H
#define OO7Module_H

#include "compiler/C/compiler.h"

DECLARE_type(OO7Module);
DECLARE_type(OO7Module_static);

struct OO7Module_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "OO7Module.externs.h"
#include "java/builtins/exports/java.h"

#include "DesignObj.h"
#include "java_lang_Object.h"
#include "CompositePart.h"
#include "Assembly.h"
#include "Manual.h"
#include "Traversal.h"
#include "OO7_Creator.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_iiabAM_TAqFp(OO7Module, Int, Int, java_lang_Object, Assembly, Manual);
extern Int	id__MRcj5(OO7Module);
extern Int	buildDate__FJfTl(OO7Module);
extern Void	set_buildDate_i_4SUpm(OO7Module, Int);
extern java_lang_Object	otype__2W6QD(OO7Module);
extern Manual	man__XZTv8(OO7Module);
extern Assembly	rootAssembly__JjN6w(OO7Module);
extern Void	add_composite_C_u6qAJ(OO7Module, CompositePart);
extern CompositePart	fetch_composite_i_eaX8Y(OO7Module, Int);
extern Int	traverse_T_aNhRn(OO7Module, Traversal);
extern Int	traverse_random_T_EuAhh(OO7Module, Traversal);
extern Int	traverse_random_path_T_Y6KKC(OO7Module, Traversal);

#ifdef __cplusplus
}
#endif

struct OO7Module_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__MRcj5)(OO7Module);
	Int (*buildDate__FJfTl)(OO7Module);
	Void (*set_buildDate_i_4SUpm)(OO7Module, Int);
	java_lang_Object (*otype__2W6QD)(OO7Module);
	Manual (*man__XZTv8)(OO7Module);
	Assembly (*rootAssembly__JjN6w)(OO7Module);
	Void (*add_composite_C_u6qAJ)(OO7Module, CompositePart);
	CompositePart (*fetch_composite_i_eaX8Y)(OO7Module, Int);
	Int (*traverse_T_aNhRn)(OO7Module, Traversal);
	Int (*traverse_random_T_EuAhh)(OO7Module, Traversal);
	Int (*traverse_random_path_T_Y6KKC)(OO7Module, Traversal);
};

struct OO7Module_bidirectional_DV {

	struct OO7Module_P_s *OO7Module_P;
	Void (*init_iiabAM_TAqFp_)(OO7Module, Int, Int, java_lang_Object, Assembly, Manual);
	Int (*id__MRcj5_)(OO7Module);
	Int (*buildDate__FJfTl_)(OO7Module);
	Void (*set_buildDate_i_4SUpm_)(OO7Module, Int);
	java_lang_Object (*otype__2W6QD_)(OO7Module);
	Manual (*man__XZTv8_)(OO7Module);
	Assembly (*rootAssembly__JjN6w_)(OO7Module);
	Void (*add_composite_C_u6qAJ_)(OO7Module, CompositePart);
	CompositePart (*fetch_composite_i_eaX8Y_)(OO7Module, Int);
	Int (*traverse_T_aNhRn_)(OO7Module, Traversal);
	Int (*traverse_random_T_EuAhh_)(OO7Module, Traversal);
	Int (*traverse_random_path_T_Y6KKC_)(OO7Module, Traversal);

	struct DesignObj_P_s *DesignObj_P;
	Void (*init__wdMWi_)(DesignObj);
	Int (*id__ipnn9_)(DesignObj);
	Int (*buildDate__xUkLN_)(DesignObj);
	Void (*set_buildDate_i_eM690_)(DesignObj, Int);
	java_lang_Object (*otype__CPNCR_)(DesignObj);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__MRcj5)(OO7Module);
	Int (*buildDate__FJfTl)(OO7Module);
	Void (*set_buildDate_i_4SUpm)(OO7Module, Int);
	java_lang_Object (*otype__2W6QD)(OO7Module);
	Manual (*man__XZTv8)(OO7Module);
	Assembly (*rootAssembly__JjN6w)(OO7Module);
	Void (*add_composite_C_u6qAJ)(OO7Module, CompositePart);
	CompositePart (*fetch_composite_i_eaX8Y)(OO7Module, Int);
	Int (*traverse_T_aNhRn)(OO7Module, Traversal);
	Int (*traverse_random_T_EuAhh)(OO7Module, Traversal);
	Int (*traverse_random_path_T_Y6KKC)(OO7Module, Traversal);
};

struct OO7Module_static_DV {

	struct DV_hdr_s hdr;

};

struct OO7Module_static_bidirectional_DV {
	struct OO7Module_P_s *OO7Module_P;

	struct DV_hdr_s hdr;

};

struct OO7Module_P_s {
	struct Class_s *CompositePart_V;
	struct Class_s *CompositePart_static_V;
	struct Class_s *Assembly_V;
	struct Class_s *Assembly_static_V;
	struct Class_s *Manual_V;
	struct Class_s *Manual_static_V;
	struct Class_s *OO7Module_V;
	struct Class_s *OO7Module_static_V;
	struct Class_s *DesignObj_V;
	struct Class_s *DesignObj_static_V;
	struct Class_s *OO7_Creator_V;
	struct Class_s *OO7_Creator_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct OO7Module_f_s {
	struct Fields_s inh;
	Int th_id_;
	Int th_buildDate_;
	Shortp th_otype_;
	Shortp th_man_;
	Shortp th_root_;
	Shortp th_composites;
	Int th_composites_i;
};

struct OO7Module_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *OO7Module_V;
extern struct Class_s *OO7Module_static_V;
extern struct OO7Module_P_s *OO7Module_P;

#endif /* OO7Module_H */
/*  Time.externs.h -- from Java class Time  */
/*  created by Toba  */

#ifndef Time_EXTERNS_H
#define Time_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Time();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Time_V;
extern struct Class_s *Time_static_V;

#endif /* Time_EXTERNS_H */
/*  Time.h -- from Java class Time  */
/*  created by Toba  */

#ifndef Time_H
#define Time_H

#include "compiler/C/compiler.h"

DECLARE_type(Time);
DECLARE_type(Time_static);

struct Time_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Time.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "Util.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__2kHJe(Time);
extern Void	init_i_fKMB6(Time, Int);
extern Void	init_ii_0mqgV(Time, Int, Int);
extern Void	init_iii_9cePQ(Time, Int, Int, Int);
extern java_lang_String	toString__w4q8F(Time);
extern java_lang_Object	write__U5uYr(Time);
extern Void	clinit__tSGHN(Time_static);

#ifdef __cplusplus
}
#endif

struct Time_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__w4q8F)(Time);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_Object (*write__U5uYr)(Time);
};

struct Time_bidirectional_DV {

	struct Time_P_s *Time_P;
	Void (*init__2kHJe_)(Time);
	Void (*init_i_fKMB6_)(Time, Int);
	Void (*init_ii_0mqgV_)(Time, Int, Int);
	Void (*init_iii_9cePQ_)(Time, Int, Int, Int);
	java_lang_String (*toString__w4q8F_)(Time);
	java_lang_Object (*write__U5uYr_)(Time);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__w4q8F)(Time);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_Object (*write__U5uYr)(Time);
};

struct Time_static_DV {

	struct DV_hdr_s hdr;

	Void (*clinit__tSGHN)(Time_static);
};

struct Time_static_bidirectional_DV {
	struct Time_P_s *Time_P;

	struct DV_hdr_s hdr;

	Void (*clinit__tSGHN)(Time_static);
};

struct Time_P_s {
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Time_V;
	struct Class_s *Time_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct Time_f_s {
	struct Fields_s inh;
	Int th_offset;
};

struct Time_static_f_s {
	struct Fields_s inh;
	Int th_AM;
	Int th_PM;
};

extern struct Class_s *Time_V;
extern struct Class_s *Time_static_V;
extern struct Time_P_s *Time_P;

#endif /* Time_H */
/*  Traversal.externs.h -- from Java class Traversal  */
/*  created by Toba  */

#ifndef Traversal_EXTERNS_H
#define Traversal_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Traversal();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Traversal_V;
extern struct Class_s *Traversal_static_V;

#endif /* Traversal_EXTERNS_H */
/*  Traversal.h -- from Java class Traversal  */
/*  created by Toba  */

#ifndef Traversal_H
#define Traversal_H

#include "compiler/C/compiler.h"

DECLARE_type(Traversal);
DECLARE_type(Traversal_static);

struct Traversal_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Traversal.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "intset.h"
#include "myUtil.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_iiiii_cegLD(Traversal, Int, Int, Int, Int, Int);
extern Int	pick_kind__8kbwG(Traversal);
extern intset	visited__Plxiu(Traversal);
extern Int	kind__W05M2(Traversal);

#ifdef __cplusplus
}
#endif

struct Traversal_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*pick_kind__8kbwG)(Traversal);
	intset (*visited__Plxiu)(Traversal);
	Int (*kind__W05M2)(Traversal);
};

struct Traversal_bidirectional_DV {

	struct Traversal_P_s *Traversal_P;
	Void (*init_iiiii_cegLD_)(Traversal, Int, Int, Int, Int, Int);
	Int (*pick_kind__8kbwG_)(Traversal);
	intset (*visited__Plxiu_)(Traversal);
	Int (*kind__W05M2_)(Traversal);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*pick_kind__8kbwG)(Traversal);
	intset (*visited__Plxiu)(Traversal);
	Int (*kind__W05M2)(Traversal);
};

struct Traversal_static_DV {

	struct DV_hdr_s hdr;

};

struct Traversal_static_bidirectional_DV {
	struct Traversal_P_s *Traversal_P;

	struct DV_hdr_s hdr;

};

struct Traversal_P_s {
	struct Class_s *intset_V;
	struct Class_s *intset_static_V;
	struct Class_s *Traversal_V;
	struct Class_s *Traversal_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *myUtil_V;
	struct Class_s *myUtil_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct Traversal_f_s {
	struct Fields_s inh;
	Shortp th_visited_;
	Int th_kind_;
	Int th_percent_t6;
	Int th_percent_t1;
	Int th_percent_t3;
};

struct Traversal_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Traversal_V;
extern struct Class_s *Traversal_static_V;
extern struct Traversal_P_s *Traversal_P;

#endif /* Traversal_H */
/*  Util.externs.h -- from Java class Util  */
/*  created by Toba  */

#ifndef Util_EXTERNS_H
#define Util_EXTERNS_H

#ifdef __cplusplus
extern "C" {
#endif
extern void Init_Util();

#ifdef __cplusplus
}
#endif

extern struct Class_s *Util_V;
extern struct Class_s *Util_static_V;

#endif /* Util_EXTERNS_H */
/*  Util.h -- from Java class Util  */
/*  created by Toba  */

#ifndef Util_H
#define Util_H

#include "compiler/C/compiler.h"

DECLARE_type(Util);
DECLARE_type(Util_static);

struct Util_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Util.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__viyll(Util);
extern java_lang_Object	concat_abab_SmVch(Util_static, java_lang_Object, java_lang_Object);
extern java_lang_Object	itostr_ii_reGNA(Util_static, Int, Int);
extern Void	clinit__iWGLS(Util_static);

#ifdef __cplusplus
}
#endif

struct Util_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
};

struct Util_bidirectional_DV {

	struct Util_P_s *Util_P;
	Void (*init__viyll_)(Util);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
};

struct Util_static_DV {

	struct DV_hdr_s hdr;

	java_lang_Object (*concat_abab_SmVch)(Util_static, java_lang_Object, java_lang_Object);
	java_lang_Object (*itostr_ii_reGNA)(Util_static, Int, Int);
	Void (*clinit__iWGLS)(Util_static);
};

struct Util_static_bidirectional_DV {
	struct Util_P_s *Util_P;

	struct DV_hdr_s hdr;

	java_lang_Object (*concat_abab_SmVch)(Util_static, java_lang_Object, java_lang_Object);
	java_lang_Object (*itostr_ii_reGNA)(Util_static, Int, Int);
	Void (*clinit__iWGLS)(Util_static);
};

struct Util_P_s {
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
};

struct Util_f_s {
	struct Fields_s inh;
};

struct Util_static_f_s {
	struct Fields_s inh;
	Shortp th_values;
};

extern struct Class_s *Util_V;
extern struct Class_s *Util_static_V;
extern struct Util_P_s *Util_P;

#endif /* Util_H */
