/*  intset.h -- from Java class intset  */
/*  created by Toba  */

#ifndef intset_H
#define intset_H

#include "compiler/C/compiler.h"

DECLARE_type(intset);
DECLARE_type(intset_static);

struct intset_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "intset.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_i_B2xLF(intset, Int);
extern Void	insert_i_uzZjP(intset, Int);
extern Boolean	member_i_J16wb(intset, Int);
extern Boolean	empty__7bOaO(intset);
extern Int	size__yHsmM(intset);
extern Void	clear__vXP5z(intset);
extern Int	find_index_i_MXwGm(intset, Int);

#ifdef __cplusplus
}
#endif

struct intset_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*insert_i_uzZjP)(intset, Int);
	Boolean (*member_i_J16wb)(intset, Int);
	Boolean (*empty__7bOaO)(intset);
	Int (*size__yHsmM)(intset);
	Void (*clear__vXP5z)(intset);
	Int (*find_index_i_MXwGm)(intset, Int);
};

struct intset_bidirectional_DV {

	struct intset_P_s *intset_P;
	Void (*init_i_B2xLF_)(intset, Int);
	Void (*insert_i_uzZjP_)(intset, Int);
	Boolean (*member_i_J16wb_)(intset, Int);
	Boolean (*empty__7bOaO_)(intset);
	Int (*size__yHsmM_)(intset);
	Void (*clear__vXP5z_)(intset);
	Int (*find_index_i_MXwGm_)(intset, Int);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Void (*insert_i_uzZjP)(intset, Int);
	Boolean (*member_i_J16wb)(intset, Int);
	Boolean (*empty__7bOaO)(intset);
	Int (*size__yHsmM)(intset);
	Void (*clear__vXP5z)(intset);
	Int (*find_index_i_MXwGm)(intset, Int);
};

struct intset_static_DV {

	struct DV_hdr_s hdr;

};

struct intset_static_bidirectional_DV {
	struct intset_P_s *intset_P;

	struct DV_hdr_s hdr;

};

struct intset_P_s {
	struct Class_s *intset_V;
	struct Class_s *intset_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Int_Array_0_V;
	struct Class_s *Int_Array_1_V;
};

struct intset_f_s {
	struct Fields_s inh;
	Shortp th_slots;
	Int th_m;
	Int th_num_elems;
};

struct intset_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *intset_V;
extern struct Class_s *intset_static_V;
extern struct intset_P_s *intset_P;

#endif /* intset_H */
