#ifndef _MARK_MAP_H
#define _MARK_MAP_H

// Mark_map tell whether an object in a given partition is marked.

class Mark_map {
public:
    Mark_map();

    bool test(Oref oref);
    // Requires that the oref is in the partition that this map is for.
    // Returns the mark bit for the oref.

    void set(Oref oref);
    // Requires that the oref is in the partition that this map is for.
    // Sets the mark bit for the oref.

    void reset();
    // Resets the entire mark map.

private:
    Bool_vector bits;
}


#endif /* _MARK_MAP_H */
