#ifndef _MM_STATS_H
#define _MM_STATS_H

// To hold statistics.

#include "utils/Timer.h"

class MM_Stats {
public:
    MM_Stats();

    // Iread statistics
    int iread;                // total ireads
    int iread_cache;          // ireads served from OR cache
    int iread_forward;        // Requests to forward ireads; without mods
    int iread_forward_mods;   // Requests to forward ireads; with mods
    int iread_forward_denied; // Denials for forwarded iread requests
    int iread_forward_timedout; // forwarded iread requests that timed out
    int iread_disk;           // ireads served from the disk
    // invariant:
    // total ireads = cache+forward+forward_mods+disk-denied-timedout
    Timer iread_forward_time;
    Timer iread_disk_time;

    void reset();

    void print();
};

#endif /* _MM_STATS_H */
