#define _PRIM_RECV_MESSAGE_H

#include "utils/basic.h"
#include "utils/bits.h"
#include "utils/recv_message.h"
#include "common/or_message.h"
#include "or/mm/logrecord.h"

class Logrecord;
class Network;

#ifndef Prim_ack_type
#define Prim_ack_type 301
#endif

#ifndef Prim_shutack_type
#define Prim_shutack_type 303
#endif

class Prim_recv_ack_msg: public Recv_message {
    // Overview: Reply to a get_root message
  public:
    Prim_recv_ack_msg();
    Define_message_type(Prim_ack_type);

//Is this the same type as back_ack
    Define_synch_msg();
    bool decode(Network *net, Ubits32 msg_id);

    Ubits32     noofrecords;
};

class Prim_recv_shutack_msg: public Recv_message {
    // Overview: Reply to a get_root message
  public:
    Prim_recv_shutack_msg();
    Define_message_type(Prim_shutack_type);

    Define_synch_msg();
    bool decode(Network *net, Ubits32 msg_id);

    Ubits32 shut_value;
};











