// Copyright 1995 Barbara Liskov

/*
\section{OR Data Structure}

We just group together the various important pieces so that we can pass
them around together conveniently.
*/

#ifndef _OR_H
#define _OR_H

#define IF_DEBUG(x) if (orx->config->debug_level >= (x))

class TM;
class MM;
class OR_config;
class Log;

class Communication;
class FE_map;
class Locator;
class OR_manager_set;
class FE_map;
class Transaction_Status;
class CacheDir;
class FE_manager;

struct OR {
    OR_config* config;
    Communication* communication;
    FE_map* fe_map;
    TM* tm;
    MM* mm;
    Log* log;
    Locator *locator;
    CacheDir* cachedir;
    OR_manager_set *or_managers;
    Transaction_Status *tstatus;
    FE_manager* fe_manager;
};

// OR instance
extern OR* orx;

#endif /* _OR_H */
