/*  java_lang_Integer.h -- from Java class java.lang.Integer  */
/*  created by Toba  */

#ifndef java_lang_Integer_H
#define java_lang_Integer_H

#include "compiler/C/compiler.h"

DECLARE_type(java_lang_Integer);
DECLARE_type(java_lang_Integer_static);

struct java_lang_Integer_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "java_lang_Integer.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Number.h"
#include "java_io_Serializable.h"
#include "java_lang_Object.h"
#include "java_lang_StringBuffer.h"
#include "java_lang_NumberFormatException.h"
#include "java_lang_String.h"
#include "java_lang_Character.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern java_lang_String	toString_ii_hvMZP(java_lang_Integer_static, Int, Int);
extern java_lang_String	toHexString_i_5R2Zu(java_lang_Integer_static, Int);
extern java_lang_String	toOctalString_i_VwI0r(java_lang_Integer_static, Int);
extern java_lang_String	toBinaryString_i_Nf6qD(java_lang_Integer_static, Int);
extern java_lang_String	toUnsignedString_ii_IaAXy(java_lang_Integer_static, Int, Int);
extern java_lang_String	toString_i_Uv8XM(java_lang_Integer_static, Int);
extern Int	parseInt_Si_B11ZD(java_lang_Integer_static, java_lang_String, Int);
extern Int	parseInt_S_SyZxB(java_lang_Integer_static, java_lang_String);
extern java_lang_Integer	valueOf_Si_J69y3(java_lang_Integer_static, java_lang_String, Int);
extern java_lang_Integer	valueOf_S_4e3dp(java_lang_Integer_static, java_lang_String);
extern Void	init_i_oO9cr(java_lang_Integer, Int);
extern Void	init_S_XSBJx(java_lang_Integer, java_lang_String);
extern Byte	byteValue__0ZnD4(java_lang_Integer);
extern Short	shortValue__l51dr(java_lang_Integer);
extern Int	intValue__e94pd(java_lang_Integer);
extern Long	longValue__IbYXp(java_lang_Integer);
extern Float	floatValue__2fBVD(java_lang_Integer);
extern Double	doubleValue__9RkDD(java_lang_Integer);
extern java_lang_String	toString__bvwIN(java_lang_Integer);
extern Int	hashCode__NNIVS(java_lang_Integer);
extern Boolean	equals_O_4ydMs(java_lang_Integer, java_lang_Object);
extern java_lang_Integer	decode_S_mS9Pl(java_lang_Integer_static, java_lang_String);

#ifdef __cplusplus
}
#endif

struct java_lang_Integer_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__NNIVS)(java_lang_Integer);
	Boolean (*equals_O_4ydMs)(java_lang_Integer, java_lang_Object);
	java_lang_String (*toString__bvwIN)(java_lang_Integer);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*intValue__e94pd)(java_lang_Integer);
	Long (*longValue__IbYXp)(java_lang_Integer);
	Float (*floatValue__2fBVD)(java_lang_Integer);
	Double (*doubleValue__9RkDD)(java_lang_Integer);
	Byte (*byteValue__0ZnD4)(java_lang_Integer);
	Short (*shortValue__l51dr)(java_lang_Integer);
};

struct java_lang_Integer_bidirectional_DV {

	struct java_lang_Integer_P_s *java_lang_Integer_P;
	Void (*init_i_oO9cr_)(java_lang_Integer, Int);
	Void (*init_S_XSBJx_)(java_lang_Integer, java_lang_String);
	Byte (*byteValue__0ZnD4_)(java_lang_Integer);
	Short (*shortValue__l51dr_)(java_lang_Integer);
	Int (*intValue__e94pd_)(java_lang_Integer);
	Long (*longValue__IbYXp_)(java_lang_Integer);
	Float (*floatValue__2fBVD_)(java_lang_Integer);
	Double (*doubleValue__9RkDD_)(java_lang_Integer);
	java_lang_String (*toString__bvwIN_)(java_lang_Integer);
	Int (*hashCode__NNIVS_)(java_lang_Integer);
	Boolean (*equals_O_4ydMs_)(java_lang_Integer, java_lang_Object);

	struct java_lang_Number_P_s *java_lang_Number_P;
	Void (*init__KSxKh_)(java_lang_Number);
	Int (*intValue__3y9Yd_)(java_lang_Number);
	Long (*longValue__Hp7sS_)(java_lang_Number);
	Float (*floatValue__7IIcJ_)(java_lang_Number);
	Double (*doubleValue__oT1ir_)(java_lang_Number);
	Byte (*byteValue__Zcx7x_)(java_lang_Number);
	Short (*shortValue__qy8uw_)(java_lang_Number);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__NNIVS)(java_lang_Integer);
	Boolean (*equals_O_4ydMs)(java_lang_Integer, java_lang_Object);
	java_lang_String (*toString__bvwIN)(java_lang_Integer);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*intValue__e94pd)(java_lang_Integer);
	Long (*longValue__IbYXp)(java_lang_Integer);
	Float (*floatValue__2fBVD)(java_lang_Integer);
	Double (*doubleValue__9RkDD)(java_lang_Integer);
	Byte (*byteValue__0ZnD4)(java_lang_Integer);
	Short (*shortValue__l51dr)(java_lang_Integer);
};

struct java_lang_Integer_static_DV {

	struct DV_hdr_s hdr;

	java_lang_String (*toString_ii_hvMZP)(java_lang_Integer_static, Int, Int);
	java_lang_String (*toHexString_i_5R2Zu)(java_lang_Integer_static, Int);
	java_lang_String (*toOctalString_i_VwI0r)(java_lang_Integer_static, Int);
	java_lang_String (*toBinaryString_i_Nf6qD)(java_lang_Integer_static, Int);
	java_lang_String (*toUnsignedString_ii_IaAXy)(java_lang_Integer_static, Int, Int);
	java_lang_String (*toString_i_Uv8XM)(java_lang_Integer_static, Int);
	Int (*parseInt_Si_B11ZD)(java_lang_Integer_static, java_lang_String, Int);
	Int (*parseInt_S_SyZxB)(java_lang_Integer_static, java_lang_String);
	java_lang_Integer (*valueOf_Si_J69y3)(java_lang_Integer_static, java_lang_String, Int);
	java_lang_Integer (*valueOf_S_4e3dp)(java_lang_Integer_static, java_lang_String);
	java_lang_Integer (*decode_S_mS9Pl)(java_lang_Integer_static, java_lang_String);
};

struct java_lang_Integer_static_bidirectional_DV {
	struct java_lang_Integer_P_s *java_lang_Integer_P;

	struct DV_hdr_s hdr;

	java_lang_String (*toString_ii_hvMZP)(java_lang_Integer_static, Int, Int);
	java_lang_String (*toHexString_i_5R2Zu)(java_lang_Integer_static, Int);
	java_lang_String (*toOctalString_i_VwI0r)(java_lang_Integer_static, Int);
	java_lang_String (*toBinaryString_i_Nf6qD)(java_lang_Integer_static, Int);
	java_lang_String (*toUnsignedString_ii_IaAXy)(java_lang_Integer_static, Int, Int);
	java_lang_String (*toString_i_Uv8XM)(java_lang_Integer_static, Int);
	Int (*parseInt_Si_B11ZD)(java_lang_Integer_static, java_lang_String, Int);
	Int (*parseInt_S_SyZxB)(java_lang_Integer_static, java_lang_String);
	java_lang_Integer (*valueOf_Si_J69y3)(java_lang_Integer_static, java_lang_String, Int);
	java_lang_Integer (*valueOf_S_4e3dp)(java_lang_Integer_static, java_lang_String);
	java_lang_Integer (*decode_S_mS9Pl)(java_lang_Integer_static, java_lang_String);
};

struct java_lang_Integer_P_s {
	struct Class_s *java_lang_StringBuffer_V;
	struct Class_s *java_lang_StringBuffer_static_V;
	struct Class_s *java_lang_NumberFormatException_V;
	struct Class_s *java_lang_NumberFormatException_static_V;
	struct Class_s *java_lang_Integer_V;
	struct Class_s *java_lang_Integer_static_V;
	struct Class_s *java_lang_Number_V;
	struct Class_s *java_lang_Number_static_V;
	struct Class_s *java_lang_Character_V;
	struct Class_s *java_lang_Character_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct java_lang_Integer_f_s {
	struct Fields_s inh;
	Int th_value;
};

struct java_lang_Integer_static_f_s {
	struct Fields_s inh;
	Int th_MIN_VALUE;
	Int th_MAX_VALUE;
};

extern struct Class_s *java_lang_Integer_V;
extern struct Class_s *java_lang_Integer_static_V;
extern struct java_lang_Integer_P_s *java_lang_Integer_P;

#endif /* java_lang_Integer_H */
