/*  java_lang_Long.h -- from Java class java.lang.Long  */
/*  created by Toba  */

#ifndef java_lang_Long_H
#define java_lang_Long_H

#include "compiler/C/compiler.h"

DECLARE_type(java_lang_Long);
DECLARE_type(java_lang_Long_static);

struct java_lang_Long_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "java_lang_Long.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Number.h"
#include "java_io_Serializable.h"
#include "java_lang_Object.h"
#include "java_lang_StringBuffer.h"
#include "java_lang_NumberFormatException.h"
#include "java_lang_String.h"
#include "java_lang_Character.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern java_lang_String	toString_li_KY9Nq(java_lang_Long_static, Long, Int);
extern java_lang_String	toHexString_l_8LHUa(java_lang_Long_static, Long);
extern java_lang_String	toOctalString_l_04vel(java_lang_Long_static, Long);
extern java_lang_String	toBinaryString_l_kT0Qt(java_lang_Long_static, Long);
extern java_lang_String	toUnsignedString_li_p9eR3(java_lang_Long_static, Long, Int);
extern java_lang_String	toString_l_9uYYL(java_lang_Long_static, Long);
extern Long	parseLong_Si_zkscF(java_lang_Long_static, java_lang_String, Int);
extern Long	parseLong_S_4pFrQ(java_lang_Long_static, java_lang_String);
extern java_lang_Long	valueOf_Si_rJJct(java_lang_Long_static, java_lang_String, Int);
extern java_lang_Long	valueOf_S_eTMwh(java_lang_Long_static, java_lang_String);
extern Void	init_l_fwi0q(java_lang_Long, Long);
extern Void	init_S_5Si39(java_lang_Long, java_lang_String);
extern Byte	byteValue__sm6IF(java_lang_Long);
extern Short	shortValue__RyLHC(java_lang_Long);
extern Int	intValue__yK598(java_lang_Long);
extern Long	longValue__6nrnk(java_lang_Long);
extern Float	floatValue__yIlqP(java_lang_Long);
extern Double	doubleValue__5Gpka(java_lang_Long);
extern java_lang_String	toString__tdA8M(java_lang_Long);
extern Int	hashCode__7pKFN(java_lang_Long);
extern Boolean	equals_O_cxU54(java_lang_Long, java_lang_Object);

#ifdef __cplusplus
}
#endif

struct java_lang_Long_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__7pKFN)(java_lang_Long);
	Boolean (*equals_O_cxU54)(java_lang_Long, java_lang_Object);
	java_lang_String (*toString__tdA8M)(java_lang_Long);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*intValue__yK598)(java_lang_Long);
	Long (*longValue__6nrnk)(java_lang_Long);
	Float (*floatValue__yIlqP)(java_lang_Long);
	Double (*doubleValue__5Gpka)(java_lang_Long);
	Byte (*byteValue__sm6IF)(java_lang_Long);
	Short (*shortValue__RyLHC)(java_lang_Long);
};

struct java_lang_Long_bidirectional_DV {

	struct java_lang_Long_P_s *java_lang_Long_P;
	Void (*init_l_fwi0q_)(java_lang_Long, Long);
	Void (*init_S_5Si39_)(java_lang_Long, java_lang_String);
	Byte (*byteValue__sm6IF_)(java_lang_Long);
	Short (*shortValue__RyLHC_)(java_lang_Long);
	Int (*intValue__yK598_)(java_lang_Long);
	Long (*longValue__6nrnk_)(java_lang_Long);
	Float (*floatValue__yIlqP_)(java_lang_Long);
	Double (*doubleValue__5Gpka_)(java_lang_Long);
	java_lang_String (*toString__tdA8M_)(java_lang_Long);
	Int (*hashCode__7pKFN_)(java_lang_Long);
	Boolean (*equals_O_cxU54_)(java_lang_Long, java_lang_Object);

	struct java_lang_Number_P_s *java_lang_Number_P;
	Void (*init__KSxKh_)(java_lang_Number);
	Int (*intValue__3y9Yd_)(java_lang_Number);
	Long (*longValue__Hp7sS_)(java_lang_Number);
	Float (*floatValue__7IIcJ_)(java_lang_Number);
	Double (*doubleValue__oT1ir_)(java_lang_Number);
	Byte (*byteValue__Zcx7x_)(java_lang_Number);
	Short (*shortValue__qy8uw_)(java_lang_Number);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__7pKFN)(java_lang_Long);
	Boolean (*equals_O_cxU54)(java_lang_Long, java_lang_Object);
	java_lang_String (*toString__tdA8M)(java_lang_Long);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*intValue__yK598)(java_lang_Long);
	Long (*longValue__6nrnk)(java_lang_Long);
	Float (*floatValue__yIlqP)(java_lang_Long);
	Double (*doubleValue__5Gpka)(java_lang_Long);
	Byte (*byteValue__sm6IF)(java_lang_Long);
	Short (*shortValue__RyLHC)(java_lang_Long);
};

struct java_lang_Long_static_DV {

	struct DV_hdr_s hdr;

	java_lang_String (*toString_li_KY9Nq)(java_lang_Long_static, Long, Int);
	java_lang_String (*toHexString_l_8LHUa)(java_lang_Long_static, Long);
	java_lang_String (*toOctalString_l_04vel)(java_lang_Long_static, Long);
	java_lang_String (*toBinaryString_l_kT0Qt)(java_lang_Long_static, Long);
	java_lang_String (*toUnsignedString_li_p9eR3)(java_lang_Long_static, Long, Int);
	java_lang_String (*toString_l_9uYYL)(java_lang_Long_static, Long);
	Long (*parseLong_Si_zkscF)(java_lang_Long_static, java_lang_String, Int);
	Long (*parseLong_S_4pFrQ)(java_lang_Long_static, java_lang_String);
	java_lang_Long (*valueOf_Si_rJJct)(java_lang_Long_static, java_lang_String, Int);
	java_lang_Long (*valueOf_S_eTMwh)(java_lang_Long_static, java_lang_String);
};

struct java_lang_Long_static_bidirectional_DV {
	struct java_lang_Long_P_s *java_lang_Long_P;

	struct DV_hdr_s hdr;

	java_lang_String (*toString_li_KY9Nq)(java_lang_Long_static, Long, Int);
	java_lang_String (*toHexString_l_8LHUa)(java_lang_Long_static, Long);
	java_lang_String (*toOctalString_l_04vel)(java_lang_Long_static, Long);
	java_lang_String (*toBinaryString_l_kT0Qt)(java_lang_Long_static, Long);
	java_lang_String (*toUnsignedString_li_p9eR3)(java_lang_Long_static, Long, Int);
	java_lang_String (*toString_l_9uYYL)(java_lang_Long_static, Long);
	Long (*parseLong_Si_zkscF)(java_lang_Long_static, java_lang_String, Int);
	Long (*parseLong_S_4pFrQ)(java_lang_Long_static, java_lang_String);
	java_lang_Long (*valueOf_Si_rJJct)(java_lang_Long_static, java_lang_String, Int);
	java_lang_Long (*valueOf_S_eTMwh)(java_lang_Long_static, java_lang_String);
};

struct java_lang_Long_P_s {
	struct Class_s *java_lang_StringBuffer_V;
	struct Class_s *java_lang_StringBuffer_static_V;
	struct Class_s *java_lang_NumberFormatException_V;
	struct Class_s *java_lang_NumberFormatException_static_V;
	struct Class_s *java_lang_Long_V;
	struct Class_s *java_lang_Long_static_V;
	struct Class_s *java_lang_Number_V;
	struct Class_s *java_lang_Number_static_V;
	struct Class_s *java_lang_Character_V;
	struct Class_s *java_lang_Character_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct java_lang_Long_f_s {
	struct Fields_s inh;
	Long th_value;
};

struct java_lang_Long_static_f_s {
	struct Fields_s inh;
	Long th_MIN_VALUE;
	Long th_MAX_VALUE;
};

extern struct Class_s *java_lang_Long_V;
extern struct Class_s *java_lang_Long_static_V;
extern struct java_lang_Long_P_s *java_lang_Long_P;

#endif /* java_lang_Long_H */
