/*  java_lang_Object.h -- from Java class java.lang.Object  */
/*  created by Toba  */

#ifndef java_lang_Object_H
#define java_lang_Object_H

#include "compiler/C/compiler.h"

DECLARE_type(java_lang_Object);
DECLARE_type(java_lang_Object_static);

struct java_lang_Object_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "java_lang_Object.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_String.h"
#include "java_lang_Throwable.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__AAyKx(java_lang_Object);
extern Int	hashCode__8wJNW(java_lang_Object);
extern Boolean	equals_O_Ba6e0(java_lang_Object, java_lang_Object);
extern java_lang_String	toString__4d9OF(java_lang_Object);
extern Void	finalize__UKxhs(java_lang_Object);

#ifdef __cplusplus
}
#endif

struct java_lang_Object_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
};

struct java_lang_Object_bidirectional_DV {

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
};

struct java_lang_Object_static_DV {

	struct DV_hdr_s hdr;

};

struct java_lang_Object_static_bidirectional_DV {
	struct java_lang_Object_P_s *java_lang_Object_P;

	struct DV_hdr_s hdr;

};

struct java_lang_Object_P_s {
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Throwable_V;
	struct Class_s *java_lang_Throwable_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct java_lang_Object_f_s {
	struct Fields_s inh;
};

struct java_lang_Object_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *java_lang_Object_V;
extern struct Class_s *java_lang_Object_static_V;
extern struct java_lang_Object_P_s *java_lang_Object_P;

#endif /* java_lang_Object_H */
