/*  java_lang_String.h -- from Java class java.lang.String  */
/*  created by Toba  */

#ifndef java_lang_String_H
#define java_lang_String_H

#include "compiler/C/compiler.h"

DECLARE_type(java_lang_String);
DECLARE_type(java_lang_String_static);

struct java_lang_String_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "java_lang_String.externs.h"
#include "java/builtins/exports/java.h"

#include "java_io_Serializable.h"
#include "java_lang_Object.h"
#include "java_lang_StringIndexOutOfBoundsException.h"
#include "java_lang_StringBuffer.h"
#include "java_lang_System.h"
#include "java_lang_Integer.h"
#include "java_lang_Long.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__0NrDw(java_lang_String);
extern Void	init_S_eIOQ5(java_lang_String, java_lang_String);
extern Void	init_ac_ippqA(java_lang_String, java_lang_Object);
extern Void	init_acii_c9aKO(java_lang_String, java_lang_Object, Int, Int);
extern Void	init_abiii_WESd4(java_lang_String, java_lang_Object, Int, Int, Int);
extern Void	init_abi_4sg8t(java_lang_String, java_lang_Object, Int);
extern Void	init_S_40YUa(java_lang_String, java_lang_StringBuffer);
extern Void	init_iiac_iYQ5t(java_lang_String, Int, Int, java_lang_Object);
extern Int	length__rpuzQ(java_lang_String);
extern Char	charAt_i_nDguX(java_lang_String, Int);
extern Void	getChars_iiaci_2mjfR(java_lang_String, Int, Int, java_lang_Object, Int);
extern Void	getBytes_iiabi_36VfN(java_lang_String, Int, Int, java_lang_Object, Int);
extern Boolean	equals_O_lnqT0(java_lang_String, java_lang_Object);
extern Int	compareTo_S_zLu8m(java_lang_String, java_lang_String);
extern Boolean	regionMatches_iSii_IKGCc(java_lang_String, Int, java_lang_String, Int, Int);
extern Boolean	startsWith_Si_05EHt(java_lang_String, java_lang_String, Int);
extern Boolean	startsWith_S_ZcCfn(java_lang_String, java_lang_String);
extern Boolean	endsWith_S_0JPFg(java_lang_String, java_lang_String);
extern Int	hashCode__mK6Su(java_lang_String);
extern Int	indexOf_i_RQbCe(java_lang_String, Int);
extern Int	indexOf_ii_GM7aw(java_lang_String, Int, Int);
extern Int	lastIndexOf_i_b5Jsb(java_lang_String, Int);
extern Int	lastIndexOf_ii_8TUP8(java_lang_String, Int, Int);
extern Int	indexOf_S_S3fj3(java_lang_String, java_lang_String);
extern Int	indexOf_Si_TnzRD(java_lang_String, java_lang_String, Int);
extern Int	lastIndexOf_S_aFM7t(java_lang_String, java_lang_String);
extern Int	lastIndexOf_Si_TpBGN(java_lang_String, java_lang_String, Int);
extern java_lang_String	substring_i_SZvgs(java_lang_String, Int);
extern java_lang_String	substring_ii_dKGgx(java_lang_String, Int, Int);
extern java_lang_String	concat_S_WOS31(java_lang_String, java_lang_String);
extern java_lang_String	replace_cc_AsLcG(java_lang_String, Char, Char);
extern java_lang_String	trim__6ufYg(java_lang_String);
extern java_lang_String	toString__ifcwd(java_lang_String);
extern java_lang_Object	toCharArray__WzJhu(java_lang_String);
extern java_lang_String	valueOf_O_6F80r(java_lang_String_static, java_lang_Object);
extern java_lang_String	valueOf_ac_4tbth(java_lang_String_static, java_lang_Object);
extern java_lang_String	valueOf_acii_0YTEz(java_lang_String_static, java_lang_Object, Int, Int);
extern java_lang_String	copyValueOf_acii_5Bxui(java_lang_String_static, java_lang_Object, Int, Int);
extern java_lang_String	copyValueOf_ac_z5SCH(java_lang_String_static, java_lang_Object);
extern java_lang_String	valueOf_z_2AoH0(java_lang_String_static, Boolean);
extern java_lang_String	valueOf_c_1r9hw(java_lang_String_static, Char);
extern java_lang_String	valueOf_i_N2qKF(java_lang_String_static, Int);
extern java_lang_String	valueOf_l_KWKSp(java_lang_String_static, Long);
extern Int	utfLength__K7b9n(java_lang_String);

#ifdef __cplusplus
}
#endif

struct java_lang_String_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__mK6Su)(java_lang_String);
	Boolean (*equals_O_lnqT0)(java_lang_String, java_lang_Object);
	java_lang_String (*toString__ifcwd)(java_lang_String);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*length__rpuzQ)(java_lang_String);
	Char (*charAt_i_nDguX)(java_lang_String, Int);
	Void (*getChars_iiaci_2mjfR)(java_lang_String, Int, Int, java_lang_Object, Int);
	Void (*getBytes_iiabi_36VfN)(java_lang_String, Int, Int, java_lang_Object, Int);
	Int (*compareTo_S_zLu8m)(java_lang_String, java_lang_String);
	Boolean (*regionMatches_iSii_IKGCc)(java_lang_String, Int, java_lang_String, Int, Int);
	Boolean (*startsWith_Si_05EHt)(java_lang_String, java_lang_String, Int);
	Boolean (*startsWith_S_ZcCfn)(java_lang_String, java_lang_String);
	Boolean (*endsWith_S_0JPFg)(java_lang_String, java_lang_String);
	Int (*indexOf_i_RQbCe)(java_lang_String, Int);
	Int (*indexOf_ii_GM7aw)(java_lang_String, Int, Int);
	Int (*lastIndexOf_i_b5Jsb)(java_lang_String, Int);
	Int (*lastIndexOf_ii_8TUP8)(java_lang_String, Int, Int);
	Int (*indexOf_S_S3fj3)(java_lang_String, java_lang_String);
	Int (*indexOf_Si_TnzRD)(java_lang_String, java_lang_String, Int);
	Int (*lastIndexOf_S_aFM7t)(java_lang_String, java_lang_String);
	Int (*lastIndexOf_Si_TpBGN)(java_lang_String, java_lang_String, Int);
	java_lang_String (*substring_i_SZvgs)(java_lang_String, Int);
	java_lang_String (*substring_ii_dKGgx)(java_lang_String, Int, Int);
	java_lang_String (*concat_S_WOS31)(java_lang_String, java_lang_String);
	java_lang_String (*replace_cc_AsLcG)(java_lang_String, Char, Char);
	java_lang_String (*trim__6ufYg)(java_lang_String);
	java_lang_Object (*toCharArray__WzJhu)(java_lang_String);
	Int (*utfLength__K7b9n)(java_lang_String);
};

struct java_lang_String_bidirectional_DV {

	struct java_lang_String_P_s *java_lang_String_P;
	Void (*init__0NrDw_)(java_lang_String);
	Void (*init_S_eIOQ5_)(java_lang_String, java_lang_String);
	Void (*init_ac_ippqA_)(java_lang_String, java_lang_Object);
	Void (*init_acii_c9aKO_)(java_lang_String, java_lang_Object, Int, Int);
	Void (*init_abiii_WESd4_)(java_lang_String, java_lang_Object, Int, Int, Int);
	Void (*init_abi_4sg8t_)(java_lang_String, java_lang_Object, Int);
	Void (*init_S_40YUa_)(java_lang_String, java_lang_StringBuffer);
	Void (*init_iiac_iYQ5t_)(java_lang_String, Int, Int, java_lang_Object);
	Int (*length__rpuzQ_)(java_lang_String);
	Char (*charAt_i_nDguX_)(java_lang_String, Int);
	Void (*getChars_iiaci_2mjfR_)(java_lang_String, Int, Int, java_lang_Object, Int);
	Void (*getBytes_iiabi_36VfN_)(java_lang_String, Int, Int, java_lang_Object, Int);
	Boolean (*equals_O_lnqT0_)(java_lang_String, java_lang_Object);
	Int (*compareTo_S_zLu8m_)(java_lang_String, java_lang_String);
	Boolean (*regionMatches_iSii_IKGCc_)(java_lang_String, Int, java_lang_String, Int, Int);
	Boolean (*startsWith_Si_05EHt_)(java_lang_String, java_lang_String, Int);
	Boolean (*startsWith_S_ZcCfn_)(java_lang_String, java_lang_String);
	Boolean (*endsWith_S_0JPFg_)(java_lang_String, java_lang_String);
	Int (*hashCode__mK6Su_)(java_lang_String);
	Int (*indexOf_i_RQbCe_)(java_lang_String, Int);
	Int (*indexOf_ii_GM7aw_)(java_lang_String, Int, Int);
	Int (*lastIndexOf_i_b5Jsb_)(java_lang_String, Int);
	Int (*lastIndexOf_ii_8TUP8_)(java_lang_String, Int, Int);
	Int (*indexOf_S_S3fj3_)(java_lang_String, java_lang_String);
	Int (*indexOf_Si_TnzRD_)(java_lang_String, java_lang_String, Int);
	Int (*lastIndexOf_S_aFM7t_)(java_lang_String, java_lang_String);
	Int (*lastIndexOf_Si_TpBGN_)(java_lang_String, java_lang_String, Int);
	java_lang_String (*substring_i_SZvgs_)(java_lang_String, Int);
	java_lang_String (*substring_ii_dKGgx_)(java_lang_String, Int, Int);
	java_lang_String (*concat_S_WOS31_)(java_lang_String, java_lang_String);
	java_lang_String (*replace_cc_AsLcG_)(java_lang_String, Char, Char);
	java_lang_String (*trim__6ufYg_)(java_lang_String);
	java_lang_String (*toString__ifcwd_)(java_lang_String);
	java_lang_Object (*toCharArray__WzJhu_)(java_lang_String);
	Int (*utfLength__K7b9n_)(java_lang_String);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__mK6Su)(java_lang_String);
	Boolean (*equals_O_lnqT0)(java_lang_String, java_lang_Object);
	java_lang_String (*toString__ifcwd)(java_lang_String);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*length__rpuzQ)(java_lang_String);
	Char (*charAt_i_nDguX)(java_lang_String, Int);
	Void (*getChars_iiaci_2mjfR)(java_lang_String, Int, Int, java_lang_Object, Int);
	Void (*getBytes_iiabi_36VfN)(java_lang_String, Int, Int, java_lang_Object, Int);
	Int (*compareTo_S_zLu8m)(java_lang_String, java_lang_String);
	Boolean (*regionMatches_iSii_IKGCc)(java_lang_String, Int, java_lang_String, Int, Int);
	Boolean (*startsWith_Si_05EHt)(java_lang_String, java_lang_String, Int);
	Boolean (*startsWith_S_ZcCfn)(java_lang_String, java_lang_String);
	Boolean (*endsWith_S_0JPFg)(java_lang_String, java_lang_String);
	Int (*indexOf_i_RQbCe)(java_lang_String, Int);
	Int (*indexOf_ii_GM7aw)(java_lang_String, Int, Int);
	Int (*lastIndexOf_i_b5Jsb)(java_lang_String, Int);
	Int (*lastIndexOf_ii_8TUP8)(java_lang_String, Int, Int);
	Int (*indexOf_S_S3fj3)(java_lang_String, java_lang_String);
	Int (*indexOf_Si_TnzRD)(java_lang_String, java_lang_String, Int);
	Int (*lastIndexOf_S_aFM7t)(java_lang_String, java_lang_String);
	Int (*lastIndexOf_Si_TpBGN)(java_lang_String, java_lang_String, Int);
	java_lang_String (*substring_i_SZvgs)(java_lang_String, Int);
	java_lang_String (*substring_ii_dKGgx)(java_lang_String, Int, Int);
	java_lang_String (*concat_S_WOS31)(java_lang_String, java_lang_String);
	java_lang_String (*replace_cc_AsLcG)(java_lang_String, Char, Char);
	java_lang_String (*trim__6ufYg)(java_lang_String);
	java_lang_Object (*toCharArray__WzJhu)(java_lang_String);
	Int (*utfLength__K7b9n)(java_lang_String);
};

struct java_lang_String_static_DV {

	struct DV_hdr_s hdr;

	java_lang_String (*valueOf_O_6F80r)(java_lang_String_static, java_lang_Object);
	java_lang_String (*valueOf_ac_4tbth)(java_lang_String_static, java_lang_Object);
	java_lang_String (*valueOf_acii_0YTEz)(java_lang_String_static, java_lang_Object, Int, Int);
	java_lang_String (*copyValueOf_acii_5Bxui)(java_lang_String_static, java_lang_Object, Int, Int);
	java_lang_String (*copyValueOf_ac_z5SCH)(java_lang_String_static, java_lang_Object);
	java_lang_String (*valueOf_z_2AoH0)(java_lang_String_static, Boolean);
	java_lang_String (*valueOf_c_1r9hw)(java_lang_String_static, Char);
	java_lang_String (*valueOf_i_N2qKF)(java_lang_String_static, Int);
	java_lang_String (*valueOf_l_KWKSp)(java_lang_String_static, Long);
};

struct java_lang_String_static_bidirectional_DV {
	struct java_lang_String_P_s *java_lang_String_P;

	struct DV_hdr_s hdr;

	java_lang_String (*valueOf_O_6F80r)(java_lang_String_static, java_lang_Object);
	java_lang_String (*valueOf_ac_4tbth)(java_lang_String_static, java_lang_Object);
	java_lang_String (*valueOf_acii_0YTEz)(java_lang_String_static, java_lang_Object, Int, Int);
	java_lang_String (*copyValueOf_acii_5Bxui)(java_lang_String_static, java_lang_Object, Int, Int);
	java_lang_String (*copyValueOf_ac_z5SCH)(java_lang_String_static, java_lang_Object);
	java_lang_String (*valueOf_z_2AoH0)(java_lang_String_static, Boolean);
	java_lang_String (*valueOf_c_1r9hw)(java_lang_String_static, Char);
	java_lang_String (*valueOf_i_N2qKF)(java_lang_String_static, Int);
	java_lang_String (*valueOf_l_KWKSp)(java_lang_String_static, Long);
};

struct java_lang_String_P_s {
	struct Class_s *java_lang_StringIndexOutOfBoundsException_V;
	struct Class_s *java_lang_StringIndexOutOfBoundsException_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_io_Serializable_V;
	struct Class_s *java_io_Serializable_static_V;
	struct Class_s *java_lang_System_V;
	struct Class_s *java_lang_System_static_V;
	struct Class_s *java_lang_StringBuffer_V;
	struct Class_s *java_lang_StringBuffer_static_V;
	struct Class_s *java_lang_Integer_V;
	struct Class_s *java_lang_Integer_static_V;
	struct Class_s *java_lang_Long_V;
	struct Class_s *java_lang_Long_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
};

struct java_lang_String_f_s {
	struct Fields_s inh;
	Shortp th_value;
	Int th_offset;
	Int th_count;
};

struct java_lang_String_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *java_lang_String_V;
extern struct Class_s *java_lang_String_static_V;
extern struct java_lang_String_P_s *java_lang_String_P;

#endif /* java_lang_String_H */
