/*  java_util_Hashtable.h -- from Java class java.util.Hashtable  */
/*  created by Toba  */

#ifndef java_util_Hashtable_H
#define java_util_Hashtable_H

#include "compiler/C/compiler.h"

DECLARE_type(java_util_Hashtable);
DECLARE_type(java_util_Hashtable_static);

struct java_util_Hashtable_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "java_util_Hashtable.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Cloneable.h"
#include "java_io_Serializable.h"
#include "java_util_Dictionary.h"
#include "java_lang_Object.h"
#include "java_lang_IllegalArgumentException.h"
#include "java_util_HashtableEntry.h"
#include "java_util_HashtableEnumerator.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_StringBuffer.h"
#include "java_util_Enumeration.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_if_IINeH(java_util_Hashtable, Int, Float);
extern Void	init_i_yOEvX(java_util_Hashtable, Int);
extern Void	init__lkK9b(java_util_Hashtable);
extern Int	size__LHWUu(java_util_Hashtable);
extern Boolean	isEmpty__W4kps(java_util_Hashtable);
extern java_util_Enumeration	keys__xGD0F(java_util_Hashtable);
extern java_util_Enumeration	elements__Cw0QT(java_util_Hashtable);
extern Boolean	contains_O_SoCET(java_util_Hashtable, java_lang_Object);
extern Boolean	containsKey_O_NPUci(java_util_Hashtable, java_lang_Object);
extern java_lang_Object	get_O_doAa7(java_util_Hashtable, java_lang_Object);
extern Void	rehash__6kYEd(java_util_Hashtable);
extern java_lang_Object	put_OO_4Xy3U(java_util_Hashtable, java_lang_Object, java_lang_Object);
extern java_lang_Object	remove_O_XahIv(java_util_Hashtable, java_lang_Object);
extern Void	clear__oZzcN(java_util_Hashtable);
extern java_lang_String	toString__1l5EQ(java_util_Hashtable);

#ifdef __cplusplus
}
#endif

struct java_util_Hashtable_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__1l5EQ)(java_util_Hashtable);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*size__LHWUu)(java_util_Hashtable);
	Boolean (*isEmpty__W4kps)(java_util_Hashtable);
	java_util_Enumeration (*keys__xGD0F)(java_util_Hashtable);
	java_util_Enumeration (*elements__Cw0QT)(java_util_Hashtable);
	java_lang_Object (*get_O_doAa7)(java_util_Hashtable, java_lang_Object);
	java_lang_Object (*put_OO_4Xy3U)(java_util_Hashtable, java_lang_Object, java_lang_Object);
	java_lang_Object (*remove_O_XahIv)(java_util_Hashtable, java_lang_Object);
	Boolean (*contains_O_SoCET)(java_util_Hashtable, java_lang_Object);
	Boolean (*containsKey_O_NPUci)(java_util_Hashtable, java_lang_Object);
	Void (*rehash__6kYEd)(java_util_Hashtable);
	Void (*clear__oZzcN)(java_util_Hashtable);
};

struct java_util_Hashtable_bidirectional_DV {

	struct java_util_Hashtable_P_s *java_util_Hashtable_P;
	Void (*init_if_IINeH_)(java_util_Hashtable, Int, Float);
	Void (*init_i_yOEvX_)(java_util_Hashtable, Int);
	Void (*init__lkK9b_)(java_util_Hashtable);
	Int (*size__LHWUu_)(java_util_Hashtable);
	Boolean (*isEmpty__W4kps_)(java_util_Hashtable);
	java_util_Enumeration (*keys__xGD0F_)(java_util_Hashtable);
	java_util_Enumeration (*elements__Cw0QT_)(java_util_Hashtable);
	Boolean (*contains_O_SoCET_)(java_util_Hashtable, java_lang_Object);
	Boolean (*containsKey_O_NPUci_)(java_util_Hashtable, java_lang_Object);
	java_lang_Object (*get_O_doAa7_)(java_util_Hashtable, java_lang_Object);
	Void (*rehash__6kYEd_)(java_util_Hashtable);
	java_lang_Object (*put_OO_4Xy3U_)(java_util_Hashtable, java_lang_Object, java_lang_Object);
	java_lang_Object (*remove_O_XahIv_)(java_util_Hashtable, java_lang_Object);
	Void (*clear__oZzcN_)(java_util_Hashtable);
	java_lang_String (*toString__1l5EQ_)(java_util_Hashtable);

	struct java_util_Dictionary_P_s *java_util_Dictionary_P;
	Void (*init__LQ5rm_)(java_util_Dictionary);
	Int (*size__5lLut_)(java_util_Dictionary);
	Boolean (*isEmpty__UOTeQ_)(java_util_Dictionary);
	java_util_Enumeration (*keys__TSnxw_)(java_util_Dictionary);
	java_util_Enumeration (*elements__edAle_)(java_util_Dictionary);
	java_lang_Object (*get_O_DmiRs_)(java_util_Dictionary, java_lang_Object);
	java_lang_Object (*put_OO_SztJw_)(java_util_Dictionary, java_lang_Object, java_lang_Object);
	java_lang_Object (*remove_O_9mH0T_)(java_util_Dictionary, java_lang_Object);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__1l5EQ)(java_util_Hashtable);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*size__LHWUu)(java_util_Hashtable);
	Boolean (*isEmpty__W4kps)(java_util_Hashtable);
	java_util_Enumeration (*keys__xGD0F)(java_util_Hashtable);
	java_util_Enumeration (*elements__Cw0QT)(java_util_Hashtable);
	java_lang_Object (*get_O_doAa7)(java_util_Hashtable, java_lang_Object);
	java_lang_Object (*put_OO_4Xy3U)(java_util_Hashtable, java_lang_Object, java_lang_Object);
	java_lang_Object (*remove_O_XahIv)(java_util_Hashtable, java_lang_Object);
	Boolean (*contains_O_SoCET)(java_util_Hashtable, java_lang_Object);
	Boolean (*containsKey_O_NPUci)(java_util_Hashtable, java_lang_Object);
	Void (*rehash__6kYEd)(java_util_Hashtable);
	Void (*clear__oZzcN)(java_util_Hashtable);
};

struct java_util_Hashtable_static_DV {

	struct DV_hdr_s hdr;

};

struct java_util_Hashtable_static_bidirectional_DV {
	struct java_util_Hashtable_P_s *java_util_Hashtable_P;

	struct DV_hdr_s hdr;

};

struct java_util_Hashtable_P_s {
	struct Class_s *java_lang_IllegalArgumentException_V;
	struct Class_s *java_lang_IllegalArgumentException_static_V;
	struct Class_s *java_util_HashtableEntry_V;
	struct Class_s *java_util_HashtableEntry_static_V;
	struct Class_s *java_util_HashtableEnumerator_V;
	struct Class_s *java_util_HashtableEnumerator_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_StringBuffer_V;
	struct Class_s *java_lang_StringBuffer_static_V;
	struct Class_s *java_util_Enumeration_V;
	struct Class_s *java_util_Enumeration_static_V;
	struct Class_s *java_util_Hashtable_V;
	struct Class_s *java_util_Hashtable_static_V;
	struct Class_s *java_util_Dictionary_V;
	struct Class_s *java_util_Dictionary_static_V;
	struct Class_s *java_lang_Cloneable_V;
	struct Class_s *java_lang_Cloneable_static_V;
	struct Class_s *java_io_Serializable_V;
	struct Class_s *java_io_Serializable_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *java_util_HashtableEntry_Array_0_V;
	struct Class_s *java_util_HashtableEntry_Array_1_V;
};

struct java_util_Hashtable_f_s {
	struct Fields_s inh;
	Shortp th_table;
	Int th_count;
	Int th_threshold;
	Float th_loadFactor;
};

struct java_util_Hashtable_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *java_util_Hashtable_V;
extern struct Class_s *java_util_Hashtable_static_V;
extern struct java_util_Hashtable_P_s *java_util_Hashtable_P;

#endif /* java_util_Hashtable_H */
