/*  Calendar.h -- from Java class Calendar  */
/*  created by Toba  */

#ifndef Calendar_H
#define Calendar_H

#include "compiler/C/compiler.h"

DECLARE_type(Calendar);
DECLARE_type(Calendar_static);

struct Calendar_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Calendar.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "Item.h"
#include "java_lang_String.h"
#include "Util.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_i_QagE5(Calendar, Int);
extern Int	id__T5S9y(Calendar);
extern Int	numItems__8lyk4(Calendar);
extern Item	getItem_i_bFaGl(Calendar, Int);
extern Void	addItem_I_3UE80(Calendar, Item);
extern Void	deleteItem_i_IsMEA(Calendar, Int);
extern java_lang_String	toFile__yaGQ3(Calendar);
extern java_lang_Object	write__vaGe9(Calendar);
extern Void	clinit__ElHl2(Calendar_static);

#ifdef __cplusplus
}
#endif

struct Calendar_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__T5S9y)(Calendar);
	Int (*numItems__8lyk4)(Calendar);
	Item (*getItem_i_bFaGl)(Calendar, Int);
	Void (*addItem_I_3UE80)(Calendar, Item);
	Void (*deleteItem_i_IsMEA)(Calendar, Int);
	java_lang_String (*toFile__yaGQ3)(Calendar);
	java_lang_Object (*write__vaGe9)(Calendar);
};

struct Calendar_bidirectional_DV {

	struct Calendar_P_s *Calendar_P;
	Void (*init_i_QagE5_)(Calendar, Int);
	Int (*id__T5S9y_)(Calendar);
	Int (*numItems__8lyk4_)(Calendar);
	Item (*getItem_i_bFaGl_)(Calendar, Int);
	Void (*addItem_I_3UE80_)(Calendar, Item);
	Void (*deleteItem_i_IsMEA_)(Calendar, Int);
	java_lang_String (*toFile__yaGQ3_)(Calendar);
	java_lang_Object (*write__vaGe9_)(Calendar);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*id__T5S9y)(Calendar);
	Int (*numItems__8lyk4)(Calendar);
	Item (*getItem_i_bFaGl)(Calendar, Int);
	Void (*addItem_I_3UE80)(Calendar, Item);
	Void (*deleteItem_i_IsMEA)(Calendar, Int);
	java_lang_String (*toFile__yaGQ3)(Calendar);
	java_lang_Object (*write__vaGe9)(Calendar);
};

struct Calendar_static_DV {

	struct DV_hdr_s hdr;

	Void (*clinit__ElHl2)(Calendar_static);
};

struct Calendar_static_bidirectional_DV {
	struct Calendar_P_s *Calendar_P;

	struct DV_hdr_s hdr;

	Void (*clinit__ElHl2)(Calendar_static);
};

struct Calendar_P_s {
	struct Class_s *Item_V;
	struct Class_s *Item_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Calendar_V;
	struct Class_s *Calendar_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Item_Array_0_V;
	struct Class_s *Item_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
};

struct Calendar_f_s {
	struct Fields_s inh;
	Int th_id;
	Int th_numItems;
	Shortp th_items;
};

struct Calendar_static_f_s {
	struct Fields_s inh;
	Int th_MAX_ITEMS;
};

extern struct Class_s *Calendar_V;
extern struct Class_s *Calendar_static_V;
extern struct Calendar_P_s *Calendar_P;

#endif /* Calendar_H */
