/*  CalendarDB.h -- from Java class CalendarDB  */
/*  created by Toba  */

#ifndef CalendarDB_H
#define CalendarDB_H

#include "compiler/C/compiler.h"

DECLARE_type(CalendarDB);
DECLARE_type(CalendarDB_static);

struct CalendarDB_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "CalendarDB.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "Calendar.h"
#include "java_lang_String.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init__dsaVt(CalendarDB);
extern Int	numCalendars__zWFsE(CalendarDB);
extern Void	addCalendar_CS_9rc72(CalendarDB, Calendar, java_lang_String);
extern Void	deleteCalendar_i_RIuXo(CalendarDB, Int);
extern Calendar	getCalendar_i_Ryhl4(CalendarDB, Int);
extern Calendar	getCalendar_S_A2LPu(CalendarDB, java_lang_String);
extern java_lang_String	getUid_i_gAGUB(CalendarDB, Int);
extern Boolean	contains_S_kpUA1(CalendarDB, java_lang_String);
extern Void	clinit__WNeZA(CalendarDB_static);

#ifdef __cplusplus
}
#endif

struct CalendarDB_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*numCalendars__zWFsE)(CalendarDB);
	Void (*addCalendar_CS_9rc72)(CalendarDB, Calendar, java_lang_String);
	Void (*deleteCalendar_i_RIuXo)(CalendarDB, Int);
	Calendar (*getCalendar_i_Ryhl4)(CalendarDB, Int);
	Calendar (*getCalendar_S_A2LPu)(CalendarDB, java_lang_String);
	java_lang_String (*getUid_i_gAGUB)(CalendarDB, Int);
	Boolean (*contains_S_kpUA1)(CalendarDB, java_lang_String);
};

struct CalendarDB_bidirectional_DV {

	struct CalendarDB_P_s *CalendarDB_P;
	Void (*init__dsaVt_)(CalendarDB);
	Int (*numCalendars__zWFsE_)(CalendarDB);
	Void (*addCalendar_CS_9rc72_)(CalendarDB, Calendar, java_lang_String);
	Void (*deleteCalendar_i_RIuXo_)(CalendarDB, Int);
	Calendar (*getCalendar_i_Ryhl4_)(CalendarDB, Int);
	Calendar (*getCalendar_S_A2LPu_)(CalendarDB, java_lang_String);
	java_lang_String (*getUid_i_gAGUB_)(CalendarDB, Int);
	Boolean (*contains_S_kpUA1_)(CalendarDB, java_lang_String);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF)(java_lang_Object);
	Void (*finalize__UKxhs)(java_lang_Object);
	Int (*numCalendars__zWFsE)(CalendarDB);
	Void (*addCalendar_CS_9rc72)(CalendarDB, Calendar, java_lang_String);
	Void (*deleteCalendar_i_RIuXo)(CalendarDB, Int);
	Calendar (*getCalendar_i_Ryhl4)(CalendarDB, Int);
	Calendar (*getCalendar_S_A2LPu)(CalendarDB, java_lang_String);
	java_lang_String (*getUid_i_gAGUB)(CalendarDB, Int);
	Boolean (*contains_S_kpUA1)(CalendarDB, java_lang_String);
};

struct CalendarDB_static_DV {

	struct DV_hdr_s hdr;

	Void (*clinit__WNeZA)(CalendarDB_static);
};

struct CalendarDB_static_bidirectional_DV {
	struct CalendarDB_P_s *CalendarDB_P;

	struct DV_hdr_s hdr;

	Void (*clinit__WNeZA)(CalendarDB_static);
};

struct CalendarDB_P_s {
	struct Class_s *Calendar_V;
	struct Class_s *Calendar_static_V;
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *CalendarDB_V;
	struct Class_s *CalendarDB_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Calendar_Array_0_V;
	struct Class_s *Calendar_Array_1_V;
	struct Class_s *java_lang_String_Array_0_V;
	struct Class_s *java_lang_String_Array_1_V;
};

struct CalendarDB_f_s {
	struct Fields_s inh;
	Shortp th_calendars;
	Shortp th_uids;
	Int th_numCalendars;
};

struct CalendarDB_static_f_s {
	struct Fields_s inh;
	Int th_MAX_CALENDARS;
};

extern struct Class_s *CalendarDB_V;
extern struct Class_s *CalendarDB_static_V;
extern struct CalendarDB_P_s *CalendarDB_P;

#endif /* CalendarDB_H */
