/*  Item.h -- from Java class Item  */
/*  created by Toba  */

#ifndef Item_H
#define Item_H

#include "compiler/C/compiler.h"

DECLARE_type(Item);
DECLARE_type(Item_static);

struct Item_P_s;

#include "compiler/toba.h"
#include "utils/th_assert.h"

#include "Item.externs.h"
#include "java/builtins/exports/java.h"

#include "java_lang_Object.h"
#include "java_lang_String.h"
#include "Date.h"
#include "Util.h"
#include "java_lang_Class.h"
#include "java_lang_NullPointerException.h"
#include "java_lang_Throwable.h"

#ifdef __cplusplus
extern "C" {
#endif

extern Void	init_SS_kc5aC(Item, java_lang_String, java_lang_String);
extern Void	init_SSDD_C4nTP(Item, java_lang_String, java_lang_String, Date, Date);
extern java_lang_String	name__l8fXo(Item);
extern java_lang_String	description__6FG4o(Item);
extern Date	start__pFEMI(Item);
extern Date	finish__y6rtU(Item);
extern java_lang_Object	write__ke04G(Item);
extern java_lang_String	toString__y21AC(Item);

#ifdef __cplusplus
}
#endif

struct Item_DV {

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__y21AC)(Item);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__ke04G)(Item);
};

struct Item_bidirectional_DV {

	struct Item_P_s *Item_P;
	Void (*init_SS_kc5aC_)(Item, java_lang_String, java_lang_String);
	Void (*init_SSDD_C4nTP_)(Item, java_lang_String, java_lang_String, Date, Date);
	java_lang_String (*name__l8fXo_)(Item);
	java_lang_String (*description__6FG4o_)(Item);
	Date (*start__pFEMI_)(Item);
	Date (*finish__y6rtU_)(Item);
	java_lang_Object (*write__ke04G_)(Item);
	java_lang_String (*toString__y21AC_)(Item);

	struct java_lang_Object_P_s *java_lang_Object_P;
	Void (*init__AAyKx_)(java_lang_Object);
	Int (*hashCode__8wJNW_)(java_lang_Object);
	Boolean (*equals_O_Ba6e0_)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__4d9OF_)(java_lang_Object);
	Void (*finalize__UKxhs_)(java_lang_Object);

	struct DV_hdr_s hdr;

	Int (*hashCode__8wJNW)(java_lang_Object);
	Boolean (*equals_O_Ba6e0)(java_lang_Object, java_lang_Object);
	java_lang_String (*toString__y21AC)(Item);
	Void (*finalize__UKxhs)(java_lang_Object);
	java_lang_String (*name__l8fXo)(Item);
	java_lang_String (*description__6FG4o)(Item);
	Date (*start__pFEMI)(Item);
	Date (*finish__y6rtU)(Item);
	java_lang_Object (*write__ke04G)(Item);
};

struct Item_static_DV {

	struct DV_hdr_s hdr;

};

struct Item_static_bidirectional_DV {
	struct Item_P_s *Item_P;

	struct DV_hdr_s hdr;

};

struct Item_P_s {
	struct Class_s *java_lang_String_V;
	struct Class_s *java_lang_String_static_V;
	struct Class_s *Date_V;
	struct Class_s *Date_static_V;
	struct Class_s *Item_V;
	struct Class_s *Item_static_V;
	struct Class_s *java_lang_Object_V;
	struct Class_s *java_lang_Object_static_V;
	struct Class_s *Util_V;
	struct Class_s *Util_static_V;
	struct Class_s *java_lang_Class_V;
	struct Class_s *java_lang_Class_static_V;
	struct Class_s *java_lang_NullPointerException_V;
	struct Class_s *java_lang_NullPointerException_static_V;
	struct Class_s *Char_Array_0_V;
	struct Class_s *Char_Array_1_V;
	struct Class_s *Byte_Array_0_V;
	struct Class_s *Byte_Array_1_V;
};

struct Item_f_s {
	struct Fields_s inh;
	Shortp th_name;
	Shortp th_description;
	Shortp th_start;
	Shortp th_finish;
};

struct Item_static_f_s {
	struct Fields_s inh;
};

extern struct Class_s *Item_V;
extern struct Class_s *Item_static_V;
extern struct Item_P_s *Item_P;

#endif /* Item_H */
