#ifndef _RANDOM_PERMUTER_H
#define _RANDOM_PERMUTER_H

// A "Random_permuter" generates a random permutation of 0..n-1.

class Random_permuter {
public:
    Random_permuter(unsigned n);
    // To generate a permutation of 0..n-1.
    // Uses space of (n) int's.

    ~Random_permuter();

    unsigned get();
    // Returns a random number in 0..n-1 not returned before.
    // Returns n if no such number.

    void reset();
    // Resets the state of "this" as of construction.

private:
    unsigned const n; // space of numbers to permute
    unsigned remain; // count of numbers yet to be returned
    unsigned *numbers; // numbers[0..remain-1] give numbers to be returned
};
    

#endif /* _RANDOM_PERMUTER_H */
